#include "QUESTS\Quest_Messages.h"
#include "QUESTS\facemaker.c" // function now moved to a separate file by KAM

bool bQuestDisableAllCommands = false; // KK

// boal -->
void GenerateQuestShip(string character_id, int iNation) // KK
{
	bool isEnemy = false;
	if(character_id == "Quest pirate") isEnemy = true;
	InitQuestCaptain(character_id, iNation, isEnemy);		// LDH 05Sep06 // KK

	ref PChar = GetMainCharacter(); // KK
	int iShipType, iTradeMoney, irank, pRank;

	//PB: Generate Rank and Skills
	pRank = sti(PChar.rank);
	if(GetShipCap()) { if((8-GetCharacterShipClass(PChar)) * 2 < pRank) { pRank = (8-GetCharacterShipClass(PChar)) * 2; } } // NK
	irank = makeint((pRank/2.0 + Rand(pRank/2)) * (2.0/3.0 + ((makefloat(GetDifficulty())-1.0)/5.0)) + 0.5);
	if(irank < 1) irank = 1;
	ref rFantom = characterFromID(character_id); // KK
	rFantom.rank = irank;

	if( sti(rFantom.nation) >= NATIONS_QUANTITY)	rFantom.nation = PIRATE; // KB- Fix Governor Pirate Quest bug // KK
													rFantom.FantomType = "war";
	if( sti(rFantom.nation) == PIRATE)				rFantom.FantomType = "pirate";
	float mult = 1.0;
	switch(rFantom.FantomType)
	{
		case "war":
			mult *= 1.25;
			rFantom.quest.officertype = OFFIC_TYPE_CAPNAVY;
			break;

		case "pirate":
			mult *= 1.5; //note this is different from AIFantom! Because the gov knows this pirate is hunting near his island!
			rFantom.quest.officertype = OFFIC_TYPE_CAPPIRATE;
			break;
	}
	rFantom.skill.freeskill  = 2*irank;
	rFantom.Perks.Freepoints = irank;
	LAi_Officer_SetSkillmodifiers_and_Perks(rFantom, 0);
	LAi_SetSkill_on_Modifier(rFantom);
	Fantom_SetRandomMoney(rFantom, rFantom.FantomType);

	SetRandomNameToCharacter(rFantom);
	rFantom.old.name = rFantom.name; // KK
	rFantom.old.lastname = rFantom.lastname; // KK

	//PB: Generate Ship
	DeleteAttribute(rFantom, "Ship");

	int maxclass, minclass;
	maxclass = GetShipMinClassForSkills(sti(rFantom.skill.Leadership), sti(rFantom.skill.Sailing));	// PB: Same limit as for player
	if(sti(rFantom.nation) == PIRATE             && maxclass < MAXPIRATECLASS)			maxclass = MAXPIRATECLASS;		// KK
	if(HasSubStr(character_id,"Coastal_Captain") && maxclass < MAXCOASTGUARDCLASS)		maxclass = MAXCOASTGUARDCLASS;	// PB
	if(GetCurrentPeriod() <= PERIOD_EARLY_EXPLORERS || GetCurrentPeriod() >= PERIOD_NAPOLEONIC)
	{
		if(sti(rFantom.nation) == HOLLAND        && maxclass < 3)						maxclass = 3;
		if(sti(rFantom.nation) == PORTUGAL       && maxclass < 3)						maxclass = 3;
	}

	minclass =			maxclass + 2;
	if(minclass > 8)	minclass = 8;

	iShipType = Force_GetShipType(maxclass, minclass, "War", sti(rFantom.nation)); // PS
	GiveShip2Character(rFantom, GetShipID(iShipType), "Ship Name", -1, sti(rFantom.nation), true, true); // PB: Generic Function
	SetRandomNameToShip(rFantom);
	Ship_SetFantomData(rFantom);

	aref arship; makearef(arship, rFantom.ship);
	ref Shiptype = GetShipByType(iShipType);
	int iMCShipClass = makeint(GetCharacterShipClass(PChar)); // KK
	if(makeint(Shiptype.Class) < iMCShipClass) mult *= 1.5;
	if(makeint(Shiptype.Class) > iMCShipClass) mult *= 0.75;
	rFantom.Points = mult * stf(GetLocalShipAttrib(arship, Shiptype, "Weight")) / 5000; // PRS3

	if(character_id == "Quest pirate")	// PB: For Governor Quest Ships only
	{
		//NK edit trademoney
		float shipmult = 5.0 * sqrt(intRet(sti(Shiptype.CannonsQuantity),sti(Shiptype.CannonsQuantity),1) * sti(GetLocalShipAttrib(arship, Shiptype, "HP")) * stf(GetLocalShipAttrib(arship, Shiptype, "SpeedRate"))); // PRS3
		float commult = 1.0 + makeint(GetSummonSkillFromName(PChar, SKILL_COMMERCE))/20.0;

		iTradeMoney = makeint(sqrt(irank) * shipmult * commult/25)*25;
		if(iTradeMoney < 100) iTradeMoney = 100;

		pchar.quest.generate_kill_quest = "begin";
		pchar.quest.generate_kill_quest.money = iTradeMoney;
		pchar.quest.generate_kill_quest.town = GetCurrentTownID();//MAXIMUS
		pchar.quest.generate_kill_quest.destination = Islands[GetCharacterCurrentIsland(Pchar)].id;
		pchar.quest.generate_kill_quest.nation = sti(rFantom.nation); // KK // MAXIMUS
		pchar.quest.generate_kill_quest.shipname = rFantom.Ship.Name;
	}
}
// boal <--

bool CreateParticleSystemOnLocator(string _location_id, string _locatorName, string _particleName)
{
	aref locator;
	if (!FindLocator(_location_id, _locatorName, &locator, true))
		return false;

	CreateParticleSystemX(_particleName,stf(locator.x),stf(locator.y),stf(locator.z), stf(locator.vz.x),stf(locator.vz.y),stf(locator.vz.z),0);
	return true;
}

int GenerateNationTrade(int nation)
{
	int i = -1;
	string friendlyNations = "";
	for(int j=0; j<NATIONS_QUANTITY; j++)
	{
		if(GetNationRelation2MainCharacter(j)==RELATION_ENEMY) continue;
		if(GetNationRelation(nation, j)==RELATION_ENEMY) continue;
		if(nation==j) continue;
		if(j==PIRATE) continue;
		string tmpNat = j;
		friendlyNations = StoreString(friendlyNations,tmpNat);
	}
	i = sti(GetRandSubString(friendlyNations));

	return i;
}

// NK -->
int GenerateGoodForTrade(int FromNat, int ToNat, ref fromprice, ref toprice) // NK add prices 05-05-12
{
	//int fstoreidx = GetTownStoreIndex(GetTownIDFromGroup(Stores[GetCharacterCurrentStore(GetMainCharacter())].group));
	int fstoreidx = GetTownStoreIndex(GetCurrentTownID());
	//trace("from " + fstoreidx + " of " + GetCurrentTownID());
	string destCol;
	string friendlyTowns = "";
	for(int j=0; j<TOWNS_QUANTITY; j++)
	{
		if(!CheckAttribute(&Towns[j],"id")) continue;
		if(!CheckAttribute(&Towns[j],"nation")) continue;
		if(CheckAttribute(&Towns[j],"skiptrade") && Towns[j].skiptrade==true) continue;//MAXIMUS: added for some towns (such as St. John's on Antigua)
		if(Towns[j].nation!=ToNat) continue;
		friendlyTowns = StoreString(friendlyTowns,Towns[j].id);
	}
	if(friendlyTowns!="")
	{
		destCol = GetRandSubString(friendlyTowns);
		while(destCol=="" || HasSubStr(destCol,",") || GetIslandIDFromTown(destCol)==GetIslandIDFromTown(GetCurrentTownId())) { destCol = GetRandSubString(friendlyTowns); }
	}
	else
	{
		switch (ToNat)
		{
			case FRANCE: destCol = FRA_COLONY; break;
			case SPAIN: destCol = SPA_COLONY; break;
			case HOLLAND: destCol = HOL_COLONY; break;
			case PORTUGAL: destCol = POR_COLONY; break;
			case ENGLAND:  destCol = RED_COLONY; break;
		}
	}
	int tstoreidx = GetTownStoreIndex(destCol);
	//trace("to " + tstoreidx + " of " + destCol);
	ref sfrom, sto;
	makeref(sfrom, Stores[fstoreidx]);
	makeref(sto, Stores[tstoreidx]);
	int gt;
	bool found = false;
	for(int i = 0; i < 512; i++) //to
	{
		gt = rand(GOODS_QUANTITY - 1); // KK
		if(CheckAttribute(Goods[gt],"skip") && sti(Goods[gt].skip)) { continue; }
		if(GetStoreGoodsType(sfrom, gt) == TRADE_TYPE_CONTRABAND_NAME) continue;
		if(GetStoreGoodsType(sfrom, gt) == TRADE_TYPE_IMPORT_NAME) continue; // Sulan: Usually to make profit, don't export import goods
		if(GetStoreGoodsType(sto, gt) == TRADE_TYPE_CONTRABAND_NAME) continue;
		if(GetStoreGoodsType(sto, gt) == TRADE_TYPE_EXPORT_NAME) continue; // Sulan: Usually to make profit, don't import export goods
		found = true;
		break;
	}

	ref PChar = GetMainCharacter();
	if(!found) gt = GOOD_CHOCOLATE;
	// yes this is not dynamic-price compliant, but then TheDiamond will be redoing the economics anyway. NK 05-05-12
	fromprice = round(makefloat(GetStoreGoodsPrice(sfrom, gt, PRICE_TYPE_BUY, &PChar, 0)) / GetCharPriceMod(&PChar, PRICE_TYPE_BUY, true));
	toprice = round(makefloat(GetStoreGoodsPrice(sto, gt, PRICE_TYPE_SELL, &PChar, 0)) / GetCharPriceMod(&PChar, PRICE_TYPE_SELL, true));
	// NK 05-05-12 <--
	return gt;
}
// NK <--

void OfficersReaction(string alignment)
{
	int iPassenger;
	ref PChar;
	PChar = GetMainCharacter();

	for (int io = 0; io<GetPassengersQuantity(pchar); io++)
	{
		iPassenger = GetPassenger(pchar, io);
		if(CheckAttribute(characters[iPassenger], "loyality"))
		{
			if (characters[iPassenger].alignment == alignment)
			{
				characters[iPassenger].loyality = makeint(characters[iPassenger].loyality) + 1;
			}
			else
			{
				characters[iPassenger].loyality = makeint(characters[iPassenger].loyality) - 1;

				if(makeint(characters[iPassenger].loyality) < 1)
				{
					PlaceCharacter(&characters[iPassenger], "goto");
					characters[iPassenger].selfdialog.filename = characters[iPassenger].dialog.filename;
					characters[iPassenger].selfdialog.currentnode = characters[iPassenger].dialog.currentnode;
					characters[iPassenger].dialog.filename = "anacleto_dialog.c";
					characters[iPassenger].dialog.currentnode = "remove";
					LAi_SetActorType(&characters[iPassenger]);
					LAi_ActorDialog(&characters[iPassenger], pchar, "player_back", 2.0, 1.0);
					LAi_SetStayType(pchar);
				}
			}
		}
	}
}

// NK itemtrade 05-03-26 move Item trader functions to items_utilite.c

string GenerateDestination()
{
	ref PChar = GetMainCharacter();
	string sdestination = "";
	string friendlyTowns = "";

//MAXIMUS -[such functions must be universal (IMHO), if we are planning to make a real Caribbean in the future]->
	for(int i=0; i<TOWNS_QUANTITY; i++)
	{
		ref ctown; makeref(ctown, Towns[i]);
		if(GetAttribute(ctown,"skiptrade") == true) continue;//MAXIMUS: added for some towns (such as St. John's on Antigua)
		if(GetNationRelation2MainCharacter(sti(ctown.nation))==RELATION_ENEMY || GetNationRelation(sti(PChar.nation), sti(ctown.nation))==RELATION_ENEMY) continue;//MAXIMUS: GetNationRelation maybe not need to be added: player will have a choice

		friendlyTowns = StoreString(friendlyTowns,ctown.id);
	}
	if (friendlyTowns != "") {
		sdestination = GetRandSubString(friendlyTowns);
		while (sdestination=="" || HasSubStr(sdestination,",") || GetIslandIDFromTown(sdestination)==GetIslandIDFromTown(GetCurrentTownId())) sdestination = GetRandSubString(friendlyTowns);
	} else {
		sdestination = DEFAULT_DESTINATION;
	}
//MAXIMUS <-[such functions must be universal (IMHO), if we are planning to make a real Caribbean in the future]-

	return sdestination;
}

void GenerateConvoyQuest()
{
	ref PChar = GetMainCharacter();
	ref rTrader = characterFromID("Quest trader"); // KK
	int iShipType, iCargoType, iTradeGoods, iTradeMoney, irank;
	irank = sti(PChar.rank); // PS
	DeleteAttribute(rTrader, "Ship");

	// PS -->
	irank = 8 - irank/2;
	if(irank < MAXMERCHANTCLASS) irank = MAXMERCHANTCLASS;
	if(irank > 5) irank = 5;
	iShipType = Force_GetShipType(7, irank, "trade", GetCurrentLocationNation()); // PB: Was personal nation???
	rTrader.ship.type = GetShipID(iShipType);
	// PS <--
	SetRandomNameToShip(rTrader);
	SetBaseShipData(rTrader);

	SetCharacterGoods(rTrader, GOOD_WHEAT, makeint(sti(rTrader.ship.crew.quantity) * FOOD_PER_CREW * (WHEAT_DAYS + RUM_DAYS))); // KK
	iTradeGoods = rand(20) + 6;
	iCargoType = GetCharacterFreeSpace(rTrader, iTradeGoods);
	AddCharacterGoods(rTrader, iTradeGoods, iCargoType);
	iTradeMoney = ((iCargoType*8+99)/100)*100 + irank;

	rTrader.money = iTradeMoney * rand(irank) + rand(100); // KK
	rTrader.reputation = iClamp(REPUTATION_MIN,REPUTATION_MAX,sti(PChar.reputation)-10+rand(20)); // PB: Near player reputation

	SetCargoLocked(rTrader, true);

	pchar.quest.generate_convoy_quest.convoymoney = iTradeMoney;
	string cDestination;
	if(CheckAttribute(pchar,"quest.generate_convoy_quest.destination"))
		cDestination = pchar.quest.generate_convoy_quest.destination;
	else
	{
		cDestination = GenerateDestination();
		pchar.quest.generate_convoy_quest.destination = cDestination;
	}
	pchar.quest.generate_convoy_quest.island = GetIslandIDFromTown(cDestination);
	if(cDestination == DEFAULT_DESTINATION || cDestination == "")
	{
		pchar.quest.generate_convoy_quest.destination = DEFAULT_DESTINATION;
		pchar.quest.generate_convoy_quest.island = DEFAULT_TRADEISLAND;
	}

// KK -->
	rTrader.nation = GetCurrentLocationNation();
	if (rand(1) == 0 && pchar.quest.generate_convoy_quest.destination != DEFAULT_DESTINATION) rTrader.nation = GetTownNation(cDestination);
	rTrader.nation.orig = rTrader.nation;
// <-- KK

	pchar.quest.generate_convoy_quest.win_condition.l1 = "Timer";
	pchar.quest.generate_convoy_quest.win_condition.l1.date.day = GetAddingDataDay(0, 20, 0);
	pchar.quest.generate_convoy_quest.win_condition.l1.date.month = GetAddingDataMonth(0, 20, 0);
	pchar.quest.generate_convoy_quest.win_condition.l1.date.year = GetAddingDataYear(0, 20, 0);
	pchar.quest.generate_convoy_quest.win_condition = "generate_convoy_quest";
	pchar.quest.generate_convoy_quest_progress = "begin";

	pchar.quest.generate_convoy_quest_failed.win_condition.l1 = "NPC_Death";
	pchar.quest.generate_convoy_quest_failed.win_condition.l1.character = "Quest trader";
	pchar.quest.generate_convoy_quest_failed.win_condition = "generate_convoy_quest_failed";
}

void TavernWaitDate(string date)
{
	int iTime, iAddTime;
	iTime = sti(environment.time);
	if (date == "wait_day")
	{
		if (iTime >= 22) iAddTime = 24 - iTime + 10;
		if (iTime <= 10) iAddTime = 10 - iTime;
		//this is handled by nextday NK 05-04-17 StoreDayUpdate();
	}
	else
	{
		if (iTime < 22) iAddTime = 22 - iTime;
	}
	LAi_Fade("", "");
	WaitDate("",0,0,0,iAddTime,1);
	RecalculateJumpTable();
}

void TavernWaitDate2(string date)
{
	int iTime, iAddTime;
	iTime = sti(environment.time);
	if (date == "wait_day")
	{
		if (iTime >= 22) iAddTime = 24 - iTime + 10;
		if (iTime <= 10) iAddTime = 10 - iTime;
		//this is handled by nextday NK 05-04-17 StoreDayUpdate();
	}
	else
	{
		if (iTime < 22) iAddTime = 22 - iTime;
	}
	WaitDate("",0,0,0,iAddTime,1);
	RecalculateJumpTable();
}

void PlaceCharacter(aref ch, string group)
{
	float locx, locy, locz;
	string homelocator;
	ref mc = GetMainCharacter(); // KK
	GetCharacterPos(mc, &locx, &locy, &locz);
	homelocator = LAi_FindNearestFreeLocator(group, locx, locy, locz);
	ChangeCharacterAddressGroup(ch, mc.location, group, homelocator);
}


// LDH - Added 05Sep06 to generate a better selection of pirate captains
// updated 18Oct06 for correct animations, take character sex from model file
string RandomCaptain(int iNation) // KK
{
	if (iNation != PIRATE && CheckAttribute(Nations[iNation], "fantomModel.m0")) return Nations[iNation].fantomModel.m0; // KK

//	A note on adding characters to this function:
//	Place the name of the character you wish to test in the line below, uncomment the line in LAi_boarding.c that says:
//	Put the surrendered captain in your hold, then go to the hold and offer to make them an officer.
//  If anything doesn't work, don't put the new character in this function.
//	If the captain works, add it to the appropriate switch statement below.
//  Note that female captains will not sit in your hold, but stand instead. The greeting voice will be wrong as well.
//	Don't forget to comment the two lines out again when you're done.

//  Uncomment the line below to test new characters.  See instructions above.
//	return "test character here";
//	return "33_Piratess10";	// Example.

	string CaptainSex = "man";
	if (rand(19) == 0) CaptainSex = "woman";		// one in 20 chance of female captain, easter egg

	if (CaptainSex == "man")
	{
		switch(rand(19))
		{
			case 0:  return "33_Ronald";	 break;
			case 1:  return "BadV";			 break;
			case 2:  return "Black_corsair"; break;
			case 3:  return "Capitan";		 break;
			case 4:  return "Capnhook";		 break;
			case 5:  return "Corsair1";		 break;
			case 6:  return "Corsair1_2";	 break;
			case 7:  return "Corsair1_3";	 break;
			case 8:  return "Corsair1_4";	 break;
			case 9:  return "Corsair2";		 break;
			case 10: return "Corsair3";		 break;
			case 11: return "Corsair4";		 break;
			case 12: return "Corsair5";		 break;
			case 13: return "Pirat1";		 break;
			case 14: return "Pirat11";		 break;
			case 15: return "Pirat13";		 break;
			case 16: return "Searcher_navy"; break;
			case 17: return "Shkiper";		 break;
			case 18: return "9Jc";			 break;
			case 19: return "9Jd";			 break;
		}
		return "Corsair3";
	}
	else
	{
		switch(rand(3))
		{
			case 0:  return "33_Piratess10";	break;
			case 1:  return "9Td";				break;
			case 2:  return "9CATa";			break;
			case 3:  return "girlpatch";		break;
		}
		return "33_Piratess10";
	}
}

// LDH --> Added 05Sep06 to get rid of problems with uninitialized data
// Taken from Characters_init.c and StoryCharacters.c
void InitQuestCaptain(string QuestCharacter, int iNation, bool isEnemy)
{
	ref mchr = GetMainCharacter(); // KK
	ref ch = CharacterFromID(QuestCharacter);
	int idx = sti(ch.index);

	int CharacterNation;
	if(isEnemy) CharacterNation = LotHostileNation(iNation);
	else		CharacterNation = iNation;

	DeleteAttribute(ch, "");

	ch.id			= QuestCharacter;
	ch.index		= idx;
	ch.old.name		= "Deadly";		// will be overwritten
	ch.old.lastname = "Pirate";
	ch.name			= TranslateString("","Deadly");		// will be overwritten
	ch.lastname		= TranslateString("","Pirate");

	ch.model	= RandomCaptain(CharacterNation);
	ch.model.entity = "NPCharacter";

	// LDH 18Oct06 fixes for characters with special animations
	// we are intentionally not using Character_PostInit()
	int mdlIndex = GetModelIndex(ch.model);
	if (mdlIndex < 0)		// just in case, especially if someone mistypes the name for a test
	{
		ch.model = "Corsair3";
		mdlIndex = GetModelIndex(ch.model);
	}
	ref mdl = &Models[mdlIndex];
	ch.model.animation = mdl.ani;
	ch.model.ani = mdl.ani;
	ch.sex = mdl.sex;
//	Facemaker(ch);		// unneeded, this is set elsewhere

	if (ch.sex == "man")
	{
// KK -->
		if (CharacterNation == PIRATE) {
			ch.sound_type = "pirate";
			ch.greeting = "Gr_Vincent Bethune";	// this gets overwritten when twin character is made
		} else {
			ch.sound_type = "soldier";
			ch.greeting = GetSoldiersGreeting(CharacterNation, "");
		}
// <-- KK
	}
	else
	{
		ch.sound_type = "female_citizen";
		ch.greeting = "Gr_Pirate_f";	// this gets overwritten when twin character is made
	}
	ch.nation = CharacterNation; // KK

	if (rand(4) < 3) {
		string pistol = "pistol" + (rand(5) + 1);
		if (ENABLE_WEAPONSMOD) pistol += stringRet(rand(1), "+", "-") + rand(2);	// LDH quality only if weaponsmod enabled - 26Dec08
		GiveItem2Character(ch, pistol);
		ch.equip.gun = pistol;
		//JRH ammo mod -->
		if (ENABLE_AMMOMOD) {	// LDH change
			TakenItems(ch, "gunpowder", 1 + rand(2));
			TakenItems(ch, "pistolbullets", 1 + rand(2));
		}
		//JRH ammo mod <--
  	}
	GiveItem2Character(ch, BLADE_LONG);
	ch.equip.blade = BLADE_LONG;
	ch.nodisarm	= 1;				// PB: Disable disarming
	ch.location	= "none";
	ch.location.group = "goto";
	ch.location.locator = "none";
	ch.location.from_sea = "";
	ch.Ship.Type = SHIP_NOTUSED_TYPE_NAME;
	ch.Dialog.Filename = "Vincent Bethune_dialog.c";	// will be overwritten
	ch.Dialog.CurrentNode = "First time";
	ch.Dialog.TempNode = ch.Dialog.CurrentNode;
	ch.quest.meeting = "0";
	ch.quest = "True";

	ch.rank 	= rand(10); // KK
	if (CharacterNation == PIRATE)
		ch.reputation = "40";
	else
		ch.reputation = rand(88) + 1;
	ch.experience = "240000";
	ch.skill.freeskill = 0;
	ch.skill.Leadership = "2";
	ch.skill.Fencing = "7";
	ch.skill.Sailing = "1";
	ch.skill.Accuracy = "6";
	ch.skill.Cannons = "5";
	ch.skill.Grappling = "1";
	ch.skill.Repair = "1";
	ch.skill.Defence = "4";
	ch.skill.Commerce = "1";
	ch.skill.Sneak = "8";
	ch.money = "10";

	ch.AbordageMode = 1;

	LAi_SetMerchantType(ch);	// makes captain cower in hold if you threaten him with a sword
	LAi_SetLoginTime(ch, 0.0, 24.0);
	LAi_SetHP(ch, 80.0, 80.0);
	LAi_NoRebirthEnable(ch);
}
// LDH <--

// KK -->
void ProcessLateLoan(string town)
{
	ref Pchar = GetMainCharacter();
	int iUsurer = GetTownUsurerIndex(town);
	if (iUsurer < 0) return;
	ref rUsurer = GetCharacter(iUsurer);
	// a simple virtual sailor --->
	ChangeCharacterReputation(Pchar, -12); //was -20
	if (CheckAttribute(Pchar, "mad_usurer"))
		Pchar.mad_usurer = makeint(Pchar.mad_usurer) + 1;
	else
		PChar.mad_usurer = 1;
	rUsurer.is_mad = true; 
	// a simple virtual sailor <--
	rUsurer.Dialog.CurrentNode = "DeadMotherfucker";

	Group_CreateGroup("Usurer_Avenger");
	GenerateQuestShip("Usurer_Avenger01", rUsurer.nation); // PB: Use Generic Function
	SetCharacterRelationBoth(GetCharacterIndex("Usurer_Avenger01"),GetMainCharacterIndex(),RELATION_ENEMY);
	Group_AddCharacter("Usurer_Avenger", "Usurer_Avenger01");
	Group_SetGroupCommander("Usurer_Avenger", "Usurer_Avenger01");

	GenerateQuestShip("Usurer_Avenger02", rUsurer.nation); // PB: Use Generic Function
	Group_addCharacter("Usurer_Avenger", "Usurer_Avenger02");

	GenerateQuestShip("Coastal_Captain03", rUsurer.nation); // PB: Use Generic Function
	Group_addCharacter("Usurer_Avenger", "Coastal_Captain03");

	Group_SetTaskAttack("Usurer_Avenger", PLAYER_GROUP);
	Group_LockTask("Usurer_Avenger");

	Encounter_SetQuestMapEncounter("Usurer_Avenger", ENCOUNTER_WAR, true, 50);
// KK todo: what if someone use only direct sail? Does quest map encounters really work?
}

void CommonQuestComplete(string sQuestName)
{
	ref PChar = GetMainCharacter();
	ref NPChar, sld;
	int i, iOfficer;
	int iDonation, iRepRank, iRep, iMult, iCost;
	int cc, iColony, iTradeGoods, iQuantityGoods, iTradeNation, iPassenger;
	float locx, locy, locz;
	float x, y, z;// MAXIMUS
	string nearloc;// MAXIMUS
	string homelocation, homegroup, homelocator, tavernfriend;
	ref port;

// JRH -->
	string weaponID = GetCharacterEquipByGroup(Pchar,GUN_ITEM_TYPE);
	aref weapon;
	Items_FindItem(weaponID, &weapon);
// <-- JRH

// KK -->
	if (HasSubStr(sQuestName, "Loans_")) {
		sQuestName = strcut(sQuestName, 6, strlen(sQuestName) - 1);
		if (GetTownIndex(sQuestName) >= 0) ProcessLateLoan(sQuestName);
		return;
	}
// <-- KK

	switch (sQuestName) {

		// PB: How about we add this into the common file???
		// Was only in "standard" folder, so might cause trouble in other storylines
		case "player_back":
			Lai_SetPlayerType(pchar);
		break;

		////////////////////////////////////////////////////////////////////////
		//     -   
		////////////////////////////////////////////////////////////////////////

		case "Rand_Smuggling": // this occurs if you fail to show up for the smuggling
			Pchar.quests.contraband.relation = makeint(Pchar.quests.contraband.relation) - 10;
			RemoveSmugglersFromShore();
		break;

		case "Rand_SmugglingRemove":
			ChangeCharacterAddressGroup(CharacterFromID("Rand_Smug01"), "None", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Rand_Smug02"), "None", "", "");
			ChangeCharacterAddressGroup(CharacterFromID("Rand_Smug03"), "None", "", "");
		break;


		//     
		case "Rand_ContrabandInterruption":

			//trace("  : " + sld.id);

			//LAi_CreateFantomCharacter(0, "soldier_eng", "", "");

			/*NK*/ sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.75, GetRandomModelForTypeNation(true, "Soldiers", GetSmugglingNation()), "", ""); // PB: Use the correct nation
			Pchar.quest.contraband.SoldierIDX2 = sld.index;
			LAi_SetActorType(sld);
			LAi_group_MoveCharacter(sld, "CoastalGuards");
			// NK - sld.skill.Fencing = makeint(Pchar.skill.Fencing) - 2 + Rand(4);
			LAi_ActorFollow(sld, Pchar, "", 120);

			/*NK*/ sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.75, GetRandomModelForTypeNation(true, "Soldiers", GetSmugglingNation()), "", ""); // PB: Use the correct nation
			Pchar.quest.contraband.SoldierIDX3 = sld.index;
			LAi_SetActorType(sld);
			LAi_group_MoveCharacter(sld, "CoastalGuards");
			// NK - sld.skill.Fencing = makeint(Pchar.skill.Fencing) - 2 + Rand(4);
			LAi_ActorFollow(sld, Pchar, "", 120);

			/*NK*/ sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.75, GetRandomModelForTypeNation(true, "Soldiers", GetSmugglingNation()), "", ""); // PB: Use the correct nation
			Pchar.quest.contraband.SoldierIDX4 = sld.index;
			LAi_SetActorType(sld);
			LAi_group_MoveCharacter(sld, "CoastalGuards");
			// NK - sld.skill.Fencing = makeint(Pchar.skill.Fencing) - 2 + Rand(4);
			LAi_ActorFollow(sld, Pchar, "", 120);

			/*NK*/ sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.75, GetRandomModelForTypeNation(true, "Soldiers", GetSmugglingNation()), "", ""); // PB: Use the correct nation
			Pchar.quest.contraband.SoldierIDX5 = sld.index;
			LAi_SetActorType(sld);
			LAi_group_MoveCharacter(sld, "CoastalGuards");
			// NK - sld.skill.Fencing = makeint(Pchar.skill.Fencing) - 2 + Rand(4);
			LAi_ActorFollow(sld, Pchar, "", 120);

			/*NK*/ sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.75, GetRandomModelForTypeNation(true, "Soldiers", GetSmugglingNation()), "", ""); // PB: Use the correct nation
			Pchar.quest.contraband.SoldierIDX6 = sld.index;
			LAi_SetActorType(sld);
			LAi_group_MoveCharacter(sld, "CoastalGuards");
			// NK - sld.skill.Fencing = makeint(Pchar.skill.Fencing) - 2 + Rand(4);
			LAi_ActorFollow(sld, Pchar, "", 120);


			// ccc stormy start; coastguard officer creation moved here so that he catches you first
			/*NK*/ sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.75, GetRandomModelForTypeNation(true, "Land_Officers", GetSmugglingNation()), "", ""); // PB: Use the correct nation
			Pchar.quest.contraband.SoldierIDX1 = sld.index;
		//	Log_SetstringToLog("    (): " + sld.index);
			//Pchar.quest.contraband.SoldierIDX1 = getCharacterIndex(sld.id);
			LAi_SetActorType(sld);
			LAi_group_MoveCharacter(sld, "CoastalGuards");
			sld.Dialog.Filename = "Coastal Guards_dialog.c";
			sld.Dialog.CurrentNode = "First time";
			// NK - sld.skill.Fencing = makeint(Pchar.skill.Fencing) - 1 + Rand(4);
		//	Log_SetstringToLog("  : " + Pchar.quest.contraband.SoldierIDX1);

			trace("  : " + sld.id);
			LAi_ActorDialog(sld, Pchar, "", 120, 0);

			SetCoastalGuardPursuit();

			Lai_QuestDelay("Rand_CoastalPatrolAppear", 1.0);
		/*	Pchar.quest.Rand_ContrabandInterruptionAtSea.win_condition.l1 = "location";
			Pchar.quest.Rand_ContrabandInterruptionAtSea.win_condition.l1.character = PChar.id;
			Pchar.quest.Rand_ContrabandInterruptionAtSea.win_condition.l1.location = Islands[GetCharacterCurrentIsland(pchar)].id;
			Pchar.quest.Rand_ContrabandInterruptionAtSea.win_condition = "Rand_ContrabandInterruptionAtSea";*/
		break;

		case "Rand_CoastalPatrolAppear":
			Trace("QUEST Rand_CoastalPatrolAppear reports: Soldier Idx = " + Pchar.quest.contraband.SoldierIDX1);
			// StartQuestMovie(true, true, true);
			// ccc stormy start; so that you can run from coastguards   LAi_SetActorTypeNoGroup(Pchar);
			// ccc LAi_ActorTurnToCharacter(Pchar, &Characters[makeint(Pchar.quest.contraband.SoldierIDX1)]);
			// ccc LAi_ActorWaitDialog(Pchar, &Characters[makeint(Pchar.quest.contraband.SoldierIDX1)]);
			LAi_LocationFightDisable(&Locations[FindLocation(pchar.location)], true);
			// ccc so that guard can challenge you

			// TIH --> fix the broken combat settings if you 'ran' from the gaurds Jul25'06
			pchar.cleanlocidx = FindLocation(pchar.location);
			Pchar.quest.Rand_ContrabandInterruptionCleanup.win_condition.l1 = "location";
			Pchar.quest.Rand_ContrabandInterruptionCleanup.win_condition.l1.character = PChar.id;
			Pchar.quest.Rand_ContrabandInterruptionCleanup.win_condition.l1.location = Islands[GetCharacterCurrentIsland(pchar)].id;
			Pchar.quest.Rand_ContrabandInterruptionCleanup.win_condition = "Rand_ContrabandInterruptionCleanup";
			/* // MapEnter is a good catch situation as well... but not as cool
			Pchar.quest.Rand_ContrabandInterruptionCleanup.win_condition.l1 = "MapEnter";
			Pchar.quest.Rand_ContrabandInterruptionCleanup.win_condition = "Rand_ContrabandInterruptionCleanup";
			*/
			// TIH <--

			//LAi_SetPlayerType(Pchar);
		break;

		// TIH --> fix the broken combat settings if you 'ran' from the gaurds Jul25'06
		case "Rand_ContrabandInterruptionCleanup":
			// if the player DID run away screaming like a little wuss, we do cleanup because the dialog never happened
			if ( CheckAttribute( &Locations[sti(pchar.cleanlocidx)],"noFight" ) ) {
				LAi_LocationFightDisable(&Locations[sti(pchar.cleanlocidx)], false);
				Pchar.quest.Rand_ContrabandInterruptionAtSeaEnded.win_condition.l1 = "MapEnter";
				Pchar.quest.Rand_ContrabandInterruptionAtSeaEnded.win_condition = "Rand_ContrabandInterruptionAtSeaEnded";
				//Pchar.quest.Rand_Smuggling.over = "yes";	// dont need to do this, it should have happened already
				//RemoveSmugglersFromShore();				// dont need to do this, it should have happened already
				// fantom soldiers are automatically removed (they are fantoms)
			}
			DeleteAttribute(pchar,"cleanlocidx");
		break;
		// TIH <--

		case "Rand_ContrabandInterruptionAtSeaEnded":
			StopCoastalGuardPursuit();
		break;







////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////LAND ENCOUNTERS QUESTS///////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////


//------------------------------------------RAIDERS----------------------------------------------------
		case "LandEnc_RaidersLogin":
			LAi_group_SetRelation("ENC_RAIDERS_GROUP", LAI_GROUP_PLAYER, LAI_GROUP_NEITRAL);

			LAi_SetCheckMinHP(characterFromID("Enc_Char1"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char1")) - 1), false, "LandEnc_RaidersFight");
			LAi_SetCheckMinHP(characterFromID("Enc_Char2"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char2")) - 1), false, "LandEnc_RaidersFight");
			LAi_SetCheckMinHP(characterFromID("Enc_Char3"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char3")) - 1), false, "LandEnc_RaidersFight");
			LAi_SetCheckMinHP(characterFromID("Enc_Char4"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char4")) - 1), false, "LandEnc_RaidersFight");
		break;


		case "LandEnc_RaidersStart":

// LDH traces 03Apr09
//TraceAndLog("Raiders Start ************");

			// LDH - A character index of -1 can happen when they've logged in but you left the area before encountering them. - 03Apr09
			// They're still there when you go back, but no longer logged in.
			// I have no idea if this will fix the problem.
			if (GetCharacterIndex("Enc_Char1") != -1)
			{
				LAi_SetActorType(CharacterFromID("Enc_Char1"));
				LAi_SetActorType(CharacterFromID("Enc_Char2"));
				LAi_SetActorType(CharacterFromID("Enc_Char3"));
				LAi_SetActorType(CharacterFromID("Enc_Char4"));

				LAi_group_MoveCharacter(CharacterFromID("Enc_Char1"), "ENC_RAIDERS_GROUP");
				LAi_group_MoveCharacter(CharacterFromID("Enc_Char2"), "ENC_RAIDERS_GROUP");
				LAi_group_MoveCharacter(CharacterFromID("Enc_Char3"), "ENC_RAIDERS_GROUP");
				LAi_group_MoveCharacter(CharacterFromID("Enc_Char4"), "ENC_RAIDERS_GROUP");

				LAi_SetCheckMinHP(characterFromID("Enc_Char1"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char1")) - 1), false, "LandEnc_RaidersFight");
				LAi_SetCheckMinHP(characterFromID("Enc_Char2"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char2")) - 1), false, "LandEnc_RaidersFight");
				LAi_SetCheckMinHP(characterFromID("Enc_Char3"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char3")) - 1), false, "LandEnc_RaidersFight");
				LAi_SetCheckMinHP(characterFromID("Enc_Char4"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char4")) - 1), false, "LandEnc_RaidersFight");

				LAi_ActorDialog(CharacterFromID("Enc_Char1"), Pchar, "", 10, 0);
				LAi_ActorDialog(CharacterFromID("Enc_Char2"), Pchar, "", 10, 0);
				LAi_ActorDialog(CharacterFromID("Enc_Char3"), Pchar, "", 10, 0);
				LAi_ActorDialog(CharacterFromID("Enc_Char4"), Pchar, "", 10, 0);

				LAi_SetFightMode(PChar, false);
				LAi_LockFightMode(Pchar, true);
			}

			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest1")) pchar.quest.LandEnc_StartingQuest1.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest2")) pchar.quest.LandEnc_StartingQuest2.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest3")) pchar.quest.LandEnc_StartingQuest3.over = "yes";

		break;

		case "LandEnc_RaidersFight":
			LAi_LockFightMode(Pchar, false);

			LAi_RemoveCheckMinHP(characterFromID("Enc_Char1"));
			LAi_RemoveCheckMinHP(characterFromID("Enc_Char2"));
			LAi_RemoveCheckMinHP(characterFromID("Enc_Char3"));
			LAi_RemoveCheckMinHP(characterFromID("Enc_Char4"));

			LAi_type_actor_Reset(CharacterFromID("Enc_Char1"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char2"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char3"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char4"));

			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char1"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char2"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char3"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char4"));

			LAi_group_MoveCharacter(CharacterFromID("Enc_Char1"), "ENC_RAIDERS_GROUP");
			LAi_group_MoveCharacter(CharacterFromID("Enc_Char2"), "ENC_RAIDERS_GROUP");
			LAi_group_MoveCharacter(CharacterFromID("Enc_Char3"), "ENC_RAIDERS_GROUP");
			LAi_group_MoveCharacter(CharacterFromID("Enc_Char4"), "ENC_RAIDERS_GROUP");

			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest1")) pchar.quest.LandEnc_StartingQuest1.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest2")) pchar.quest.LandEnc_StartingQuest2.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest3")) pchar.quest.LandEnc_StartingQuest3.over = "yes";

			LAi_group_FightGroups("ENC_RAIDERS_GROUP", LAI_GROUP_PLAYER, false);
		break;

		case "LandEnc_RaidersRunAway":
			LAi_LockFightMode(Pchar, false);

			LAi_type_actor_Reset(CharacterFromID("Enc_Char1"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char2"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char3"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char4"));

			LAi_ActorAfraid(CharacterFromID("Enc_Char1"), Pchar, true);
			LAi_ActorAfraid(CharacterFromID("Enc_Char2"), Pchar, true);
			LAi_ActorAfraid(CharacterFromID("Enc_Char3"), Pchar, true);
			LAi_ActorAfraid(CharacterFromID("Enc_Char4"), Pchar, true);

			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest1")) pchar.quest.LandEnc_StartingQuest1.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest2")) pchar.quest.LandEnc_StartingQuest2.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest3")) pchar.quest.LandEnc_StartingQuest3.over = "yes";

			Characters[GetCharacterIndex("Enc_Char1")].Dialog.CurrentNode = "GetTheHellOut";
			Characters[GetCharacterIndex("Enc_Char2")].Dialog.CurrentNode = "GetTheHellOut";
			Characters[GetCharacterIndex("Enc_Char3")].Dialog.CurrentNode = "GetTheHellOut";
			Characters[GetCharacterIndex("Enc_Char4")].Dialog.CurrentNode = "GetTheHellOut";
		break;

		case "LandEnc_RaidersNoFight":
			LAi_LockFightMode(Pchar, false);

			LAi_type_actor_Reset(CharacterFromID("Enc_Char1"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char2"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char3"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char4"));

			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char1"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char2"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char3"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char4"));

			LAi_warrior_DialogEnable(CharacterFromID("Enc_Char1"), true);
			LAi_warrior_DialogEnable(CharacterFromID("Enc_Char2"), true);
			LAi_warrior_DialogEnable(CharacterFromID("Enc_Char3"), true);
			LAi_warrior_DialogEnable(CharacterFromID("Enc_Char4"), true);

			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest1")) pchar.quest.LandEnc_StartingQuest1.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest2")) pchar.quest.LandEnc_StartingQuest2.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest3")) pchar.quest.LandEnc_StartingQuest3.over = "yes";

			Characters[GetCharacterIndex("Enc_Char1")].Dialog.CurrentNode = "GetLost";
			Characters[GetCharacterIndex("Enc_Char2")].Dialog.CurrentNode = "GetLost";
			Characters[GetCharacterIndex("Enc_Char3")].Dialog.CurrentNode = "GetLost";
			Characters[GetCharacterIndex("Enc_Char4")].Dialog.CurrentNode = "GetLost";
		break;

		case "LandEnc_RaidersRobbed":
			LAi_LockFightMode(Pchar, false);

			LAi_type_actor_Reset(CharacterFromID("Enc_Char1"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char2"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char3"));
			LAi_type_actor_Reset(CharacterFromID("Enc_Char4"));

			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char1"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char2"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char3"));
			LAi_SetWarriorTypeNoGroup(CharacterFromID("Enc_Char4"));

			LAi_warrior_DialogEnable(CharacterFromID("Enc_Char1"), true);
			LAi_warrior_DialogEnable(CharacterFromID("Enc_Char2"), true);
			LAi_warrior_DialogEnable(CharacterFromID("Enc_Char3"), true);
			LAi_warrior_DialogEnable(CharacterFromID("Enc_Char4"), true);

			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest1")) pchar.quest.LandEnc_StartingQuest1.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest2")) pchar.quest.LandEnc_StartingQuest2.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest3")) pchar.quest.LandEnc_StartingQuest3.over = "yes";

			Characters[GetCharacterIndex("Enc_Char1")].Dialog.CurrentNode = "OnceAgain";
			Characters[GetCharacterIndex("Enc_Char2")].Dialog.CurrentNode = "OnceAgain";
			Characters[GetCharacterIndex("Enc_Char3")].Dialog.CurrentNode = "OnceAgain";
			Characters[GetCharacterIndex("Enc_Char4")].Dialog.CurrentNode = "OnceAgain";
		break;


//------------------------------------------RAPERS----------------------------------------------------

// Viper - Rapers MOD Start
		case "LandEnc_RapersLogin":

			Characters[GetCharacterIndex("Enc_Char2")].nodisarm = 1; // PB: Disable disarming
			Characters[GetCharacterIndex("Enc_Char3")].nodisarm = 1; // PB: Disable disarming
			Characters[GetCharacterIndex("Enc_Char4")].nodisarm = 1; // PB: Disable disarming

			LAi_group_SetRelation("ENC_RAIDERS_GROUP", LAI_GROUP_PLAYER, LAI_GROUP_NEITRAL);

			LAi_SetCheckMinHP(characterFromID("Enc_Char2"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char2")) - 1), false, "LandEnc_RapersFight");
			LAi_SetCheckMinHP(characterFromID("Enc_Char3"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char3")) - 1), false, "LandEnc_RapersFight");
			LAi_SetCheckMinHP(characterFromID("Enc_Char4"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char4")) - 1), false, "LandEnc_RapersFight");

			LAi_QuestDelay("LandEnc_RapersPursue", 1); // NK was 5
		break;

		case "LandEnc_RapersPursue":
			LAi_SetActorType(CharacterFromID("Enc_Char1"));
			LAi_SetActorType(CharacterFromID("Enc_Char2"));
			LAi_SetActorType(CharacterFromID("Enc_Char3"));
			LAi_SetActorType(CharacterFromID("Enc_Char4"));

			//       
			LAi_ActorAfraid(CharacterFromID("Enc_Char1"), CharacterFromID("Enc_Char2"), true);
			LAi_ActorFollow(CharacterFromID("Enc_Char2"), CharacterFromID("Enc_Char1"), "", 240);
			LAi_ActorFollow(CharacterFromID("Enc_Char3"), CharacterFromID("Enc_Char1"), "", 240);
			LAi_ActorFollow(CharacterFromID("Enc_Char4"), CharacterFromID("Enc_Char1"), "", 240);

			LAi_ActorDialog(CharacterFromID("Enc_Char1"), Pchar, "", 45, 0);

			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest1")) pchar.quest.LandEnc_StartingQuest1.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest2")) pchar.quest.LandEnc_StartingQuest2.over = "yes";
			if(CheckAttribute(Pchar, "quest.LandEnc_StartingQuest3")) pchar.quest.LandEnc_StartingQuest3.over = "yes";
		break;
// Viper - Rapers MOD End

		case "LandEnc_RapersTalk":
			LAi_SetActorType(CharacterFromID("Enc_Char2"));
			LAi_SetActorType(CharacterFromID("Enc_Char3"));
			LAi_SetActorType(CharacterFromID("Enc_Char4"));

			LAi_ActorAfraid(CharacterFromID("Enc_Char1"), CharacterFromID("Enc_Char2"), true);

			LAi_SetCheckMinHP(characterFromID("Enc_Char2"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char2")) - 1), false, "LandEnc_RapersFight");
			LAi_SetCheckMinHP(characterFromID("Enc_Char3"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char3")) - 1), false, "LandEnc_RapersFight");
			LAi_SetCheckMinHP(characterFromID("Enc_Char4"), (LAi_GetCharacterHP(CharacterFromID("Enc_Char4")) - 1), false, "LandEnc_RapersFight");

			LAi_ActorDialog(CharacterFromID("Enc_Char2"), Pchar, "", 1, 0);
			LAi_ActorDialog(CharacterFromID("Enc_Char3"), Pchar, "", 1, 0);
			LAi_ActorDialog(CharacterFromID("Enc_Char4"), Pchar, "", 1, 0);
		break;

		case "LandEnc_RapersFight":
			LAi_RemoveCheckMinHP(characterFromID("Enc_Char2"));
			LAi_RemoveCheckMinHP(characterFromID("Enc_Char3"));
			LAi_RemoveCheckMinHP(characterFromID("Enc_Char4"));

			LAi_SetWarriorType(CharacterFromID("Enc_Char2"));
			LAi_SetWarriorType(CharacterFromID("Enc_Char3"));
			LAi_SetWarriorType(CharacterFromID("Enc_Char4"));

			LAi_group_MoveCharacter(CharacterFromID("Enc_Char2"), "ENC_RAPERS_GROUP");
			LAi_group_MoveCharacter(CharacterFromID("Enc_Char3"), "ENC_RAPERS_GROUP");
			LAi_group_MoveCharacter(CharacterFromID("Enc_Char4"), "ENC_RAPERS_GROUP");

			Pchar.quest.LandEnc_KillAllRapers.win_condition.l1 = "NPC_Death";
			Pchar.quest.LandEnc_KillAllRapers.win_condition.l1.character = "Enc_Char2";
			Pchar.quest.LandEnc_KillAllRapers.win_condition.l2 = "NPC_Death";
			Pchar.quest.LandEnc_KillAllRapers.win_condition.l2.character = "Enc_Char3";
			Pchar.quest.LandEnc_KillAllRapers.win_condition.l3 = "NPC_Death";
			Pchar.quest.LandEnc_KillAllRapers.win_condition.l3.character = "Enc_Char4";
			PChar.quest.LandEnc_KillAllRapers.win_condition = "LandEnc_KillAllRapers";

			LAi_ActorAfraid(CharacterFromID("Enc_Char1"), CharacterFromID("Enc_Char2"), true);

			LAi_group_FightGroups("ENC_RAPERS_GROUP", LAI_GROUP_PLAYER, false);
		break;

		case "LandEnc_RapersNoFight":

			ChangeCharacterReputation(PChar, -5); // NK - Pchar.reputation = makeint(Pchar.reputation) - 5;

			LAi_ActorAfraid(CharacterFromID("Enc_Char1"), CharacterFromID("Enc_Char2"), true);

			LAi_ActorFollow(CharacterFromID("Enc_Char2"), CharacterFromID("Enc_Char1"), "", -1);
			LAi_ActorFollow(CharacterFromID("Enc_Char3"), CharacterFromID("Enc_Char1"), "", -1);
			LAi_ActorFollow(CharacterFromID("Enc_Char4"), CharacterFromID("Enc_Char1"), "", -1);

		break;

		case "LandEnc_KillAllRapers":
			//Pchar.reputation = makeint(Pchar.reputation) + 5;
			if(AUTO_SKILL_SYSTEM) { AddPartyExpChar(pchar, "Leadership", makeint(Pchar.rank)*100); }
			else { AddPartyExp(pchar, makeint(Pchar.rank)*100); }
			LAi_type_actor_Reset(CharacterFromID("Enc_Char1"));
			Characters[GetCharacterIndex("Enc_Char1")].Dialog.CurrentNode = "ThanksForHelp";
			LAi_ActorDialog(CharacterFromID("Enc_Char1"), Pchar, "", 15, 0);

		break;

//------------------------------------------OFFICER----------------------------------------------------

		case "LandEnc_OfficerHired":
		// This action is still used by the following applications:
		// 		Enc_fort_dialog.c
		// 		Enc_Officer_dialog.c
		// This is NO LONGER used by the following:
		// 		Cabinfight_dialog.c
		// 		Prisoned_dialog.c

			int freeidx = FindFreeRandomOfficer(); // NK do once
			if(freeidx != -1)
			{
				Pchar.quest.FreeRandomOfficerIdx = Characters[freeidx].index;
				Pchar.quest.FreeRandomOfficerID = Characters[makeint(Pchar.quest.FreeRandomOfficerIdx)].id;

				trace("Free Random Officer IDX is " + Pchar.quest.FreeRandomOfficerIdx + " and he has id  " + Pchar.quest.FreeRandomOfficerID);

				CopyAttributes(&Characters[makeint(Pchar.quest.FreeRandomOfficerIdx)], &Characters[makeint(Pchar.quest.HiringOfficerIDX)]);

				Characters[makeint(Pchar.quest.FreeRandomOfficerIdx)].index = Pchar.quest.FreeRandomOfficerIdx;
				Characters[makeint(Pchar.quest.FreeRandomOfficerIdx)].id = Pchar.quest.FreeRandomOfficerID;
// added by MAXIMUS [for placing new officer in empty slot (default for some officers)] -->
				int ofNum = 3;
				switch(Characters[makeint(Pchar.quest.FreeRandomOfficerIdx)].quest.officertype)
				{
					case OFFIC_TYPE_FIRSTMATE: ofNum = 1; break;
					case OFFIC_TYPE_BOATSWAIN: ofNum = 2; break;
					case OFFIC_TYPE_NAVIGATOR: ofNum = 3; break;
				}
				SetOfficersIndex(Pchar, ofNum, makeint(Pchar.quest.FreeRandomOfficerIdx));
// added by MAXIMUS [for placing new officer in empty slot (default for some officers)] <--

				Characters[makeint(Pchar.quest.FreeRandomOfficerIdx)].location = "None";

			/*	Pchar.quest.LandEnc_OfficerJoined.win_condition.l1 = "ExitFromLocation";
				Pchar.quest.LandEnc_OfficerJoined.win_condition.l1.location = Pchar.location;
				Pchar.quest.LandEnc_OfficerJoined.win_condition = "LandEnc_OfficerJoined";*/

				// TIH --> move any money they may have into their wealth, so MC cant steal their money Oct31'06
				ref NewOfficer = GetCharacter(sti(Pchar.quest.FreeRandomOfficerIdx));
				// this is copied from the TIH_OfficerHiredProcess function
				// since this questaction has yet to be converted to use that function
				if (CheckAttribute(NewOfficer,"money") && sti(NewOfficer.money) > 0)
				{
					if (!CheckAttribute(NewOfficer,"wealth")) { NewOfficer.wealth = 0; } // set if not set
					NewOfficer.wealth = makeint(sti(NewOfficer.wealth) + sti(NewOfficer.money)); // merge together into wealth
					NewOfficer.money = 0; // clear out their money now that its moved
				}
				// TIH <--

				ApplyOfficerTypeClass(NewOfficer);
				// this for the case a new officer posseses items that modify his
				// skills - on normal hiring, this is not the case, but eventually
				// a quest character does...
				UpdateSkillModifiers(NewOfficer);

				if(Characters[makeint(Pchar.quest.HiringOfficerIDX)].chr_ai.type==LAI_TYPE_SIT) LAi_Fade("LandEnc_OfficerJoined", "");
				else LAi_QuestDelay("LandEnc_OfficerJoined",0);
			}
			else
			{
				Log_SetStringToLog(QUEST_MESSAGE12);
				DeleteAttribute(Pchar, "quest.FreeRandomOfficerIdx");
				DeleteAttribute(Pchar, "quest.FreeRandomOfficerID");
			}
		break;

		case "LandEnc_OfficerJoined":
			characters[makeint(Pchar.quest.FreeRandomOfficerIdx)].Dialog.CurrentNode = "hired";
			// boal 05.09.03 offecer need to go to abordage -->
			characters[makeint(Pchar.quest.FreeRandomOfficerIdx)].AbordageMode = makeint(1);
			// boal 05.09.03 offecer need to go to abordage <--
			//MAXIMUS: process with random officers, made from citizens, will look realistic -->
			if(Characters[makeint(Pchar.quest.HiringOfficerIDX)].chr_ai.type==LAI_TYPE_SIT)
			{
				ChangeCharacterAddressGroup(&Characters[makeint(Pchar.quest.HiringOfficerIDX)], "None", "", "");
				PlaceCharacter(characterFromID(Pchar.quest.FreeRandomOfficerID), "goto");
				DialogMain(characterFromID(Pchar.quest.FreeRandomOfficerID)); // added by MAXIMUS
			}
			else
			{
				Characters[makeint(Pchar.quest.HiringOfficerIDX)].location = PChar.location;
				Characters[makeint(Pchar.quest.HiringOfficerIDX)].Dialog.Filename = "";
				Characters[makeint(Pchar.quest.HiringOfficerIDX)].Dialog.CurrentNode = "";
				LAi_group_MoveCharacter(&Characters[makeint(Pchar.quest.HiringOfficerIDX)], LAI_GROUP_PLAYER);
				LAi_SetActorType(&Characters[makeint(Pchar.quest.HiringOfficerIDX)]);
				LAi_ActorRunToLocation(&Characters[makeint(Pchar.quest.HiringOfficerIDX)], "reload", LocatorExitSence(PChar.location, "from", "house"), "none", "", "", "", -1);
			}
			//MAXIMUS: process with random officers, made from citizens, will look realistic <--

			DeleteAttribute(Pchar, "quest.FreeRandomOfficerIdx");
			DeleteAttribute(Pchar, "quest.FreeRandomOfficerID");
			DeleteAttribute(Pchar, "quest.HiringOfficerIDX");
// added by MAXIMUS [for officers icons updates after new officer hire] -->
			PostEvent(EVENT_CHANGE_OFFICERS, 500);//MAXIMUS: officers-icons fixed
// added by MAXIMUS [for officers icons updates after new officer hire] <--

			if(CheckAttribute(Pchar, "quest.OldCrewMember"))
			{
				PChar.quest.ResetCrewmember.win_condition.l1 = "ExitFromLocation";
				PChar.quest.ResetCrewmember.win_condition.l1.character = PChar.id;
				PChar.quest.ResetCrewmember.win_condition.l1.location = PChar.location;
				PChar.quest.ResetCrewmember.win_condition = "ResetCrewmember";
			}
		break;

		case "ResetCrewmember":
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].name = TranslateString("","TEST");
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].lastname = TranslateString("","");
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].Dialog.Filename = "permanent_crewmember_dialog.c";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].Dialog.CurrentNode = "First time";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Leadership = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Fencing = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Sailing = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Accuracy = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Cannons = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Grappling = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Repair = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Defence = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Commerce = "1";
			characters[GetCharacterIndex(Pchar.quest.OldCrewMember)].skill.Sneak = "1";
			SetModelFromID(CharacterFromID(Pchar.quest.OldCrewMember), GetRandomModelForTypeSex(true, "Sailors", "man"));
			DeleteAttribute(Pchar, "quest.OldCrewMember");
		break;

		case "LandEnc_OfficerFired":
			NPChar = GetCharacter(sti(Pchar.quest.FiringOfficerIDX));
			RemovePassenger(Pchar, NPChar);
			LAi_SetCitizenType(NPChar);
			NPChar.Dialog.CurrentNode = "Fired";
			NPChar.location = "none";

			DeleteAttribute(Pchar, "quest.FiringOfficerIDX");
			BLI_UpdateOfficers();
		break;

		// SA (NK bugfix 04-09-06) -->
		case "LandEnc_OfficerFiredGood":
			NPChar = GetCharacter(sti(Pchar.quest.FiringOfficerIDX));
			RemovePassenger(Pchar, NPChar);
			LAi_SetCitizenType(NPChar);
			NPChar.Dialog.CurrentNode = "Departed";
			// Maybe we should change this? But doing so would mean we'd have to keep the slot open...
			NPChar.location = "none";

			DeleteAttribute(Pchar, "quest.FiringOfficerIDX");
			BLI_UpdateOfficers();
		break;
		// SA <--

		// SA (NK bugfix 04-09-06) -->
		case "LandEnc_OfficerFiredGoodPayed":
			NPChar = GetCharacter(sti(Pchar.quest.FiringOfficerIDX));
			int PayOwed = 0;
			if(CheckAttribute(NPChar,"quest.OfficerPayOwed")) PayOwed += sti(NPChar.quest.OfficerPayOwed);
			if (GetCharacterMoney(PChar) < PayOwed) PayOwed = GetCharacterMoney(PChar);

			AddMoneyToCharacter(Pchar,-PayOwed);
			AddWealthToCharacter(&NPChar, PayOwed);
			NPChar.quest.OfficerPayOwed = 0;

			RemovePassenger(Pchar, NPChar);
			LAi_SetCitizenType(NPChar);
			NPChar.Dialog.CurrentNode = "Departed";
			// Maybe we should change this? But doing so would mean we'd have to keep the slot open...
			NPChar.location = "none";

			DeleteAttribute(Pchar, "quest.FiringOfficerIDX");
			BLI_UpdateOfficers();
		break;
		// SA <--

		// boal 05.09.03 offecer need to go to abordage -->
		case "Boal_LandEnc_OfficerStay":
			SetCharacterTask_Stay(Characters[makeint(Pchar.quest.HiringOfficerIDX)]);
			DeleteAttribute(Pchar, "quest.HiringOfficerIDX");
		break;
		// boal 05.09.03 offecer need to go to abordage <--

//------------------------------------------END OFFICER------------------------------------------------

		// NK -->
		case "NK_FightMonstersEvent":
			/*LAi_group_FightGroups(LAI_GROUP_MONSTERS, PLAYER_GROUP, false);

			for(int i = 0; i < 32; i++)
			{
				chr = &Characters[LOC_FANTOM_CHARACTERS + i];
				if(!CheckAttribute(chr,"chr_ai.group")) continue;
				if(chr.chr_ai.group == LAI_GROUP_MONSTERS)
				{
					EnableEquip(chr, BLADE_ITEM_TYPE, true);
					EquipCharacterByItem(chr, FindCharacterItemByGroup(chr, BLADE_ITEM_TYPE));
					ExecuteCharacterEquip(chr);
					if(CheckAttribute(chr,"patroltype"))
					{
						LAi_type_patrol_Init(chr);
					}
					LAi_SetWarriorType(chr);
					LAi_warrior_SetStay(chr, true);
				}
			}*/
		break;
		// NK <--

		case "removed_officer_runaway":
			GetCharacterPos(PChar, &locx, &locy, &locz);
			iOfficer = sti(pchar.removed_officer);
			LAi_ActorRunToLocation(&characters[iOfficer], "reload", LAi_FindNearestFreeLocator("reload", locx, locy, locz), characters[iOfficer].homelocation, characters[iOfficer].homelocation.group, characters[iOfficer].homelocation.locator, "removing_officer_comleted", 10.0);
		break;

		case "removing_officer_comleted":
			iOfficer = sti(pchar.removed_officer);
			switch (characters[iOfficer].homestate)
			{
				case "sit": LAi_SetSitType(&characters[iOfficer]); break;
				case "citizen": LAi_SetCitizenType(&characters[iOfficer]); break;
			}
			characters[iOfficer].dialog.currentnode = "hired_again";
		break;

		case "donation":
// LDH --> 23Sep06 total rewrite, math is identical but simplified and fixed some bugs
			iDonation = sti(pchar.quest.donate);
			iRepRank = makeint(pow(sti(PChar.rank),1.25));	// same as makeint(sqrt(sqrt(sti(PChar.rank)^5))) but without overflow problems

			while (iDonation > 0)
			{
				// Determine cost per point of reputation increase
				iRep = sti(PChar.reputation);
				iMult = 1;
				if (iabs(45-iRep) > 5)  iMult = 2;
				if (iabs(45-iRep) > 10) iMult = 4;	// original code would not have used this, was a bug I think
				if (iabs(45-iRep) > 15) iMult = 8;
				if (iabs(45-iRep) > 25) iMult = 16;
				iCost = (iRepRank * 500) * iMult;

				if (iDonation >= iCost) {
					ChangeCharacterReputation(PChar, 9999); // special case for donations, adds 1 without doubling
					iDonation -= iCost;
					if (iDonation == 0) PChar.quest.donate = 0;
				} else {
					PChar.quest.donate = iDonation;	// if there's any left over, save it for next time
					iDonation = 0;		// tell the loop we're done
				}
			}
/*
Cost for raising a character from the lowest rep (1) to the highest (89)
Cost for level 10 is  7,131,500
Cost for level 20 is 17,619,000
Cost for level 30 is 29,365,000
Cost for level 40 is 41,950,000
Cost for level 50 is 55,374,000
*/
// LDH <--
		break;

		//GENERATE
		case "generate_trade_quest":
			if (pchar.quest.generate_trade_quest_progress == "begin")
			{
				pchar.quest.generate_trade_quest_progress = "failed";
				Log_SetStringToLog(QUEST_MESSAGE2);
				AddQuestRecord("trade", 2);
			}
		break;

		case "trade_quest_open":
			iTradeGoods = sti(pchar.quest.generate_trade_quest_progress.iTradeGoods);
			iQuantityGoods = sti(pchar.quest.generate_trade_quest_progress.iQuantityGoods);
			iTradeNation = sti(pchar.quest.generate_trade_quest_progress.iTradeNation);

			AddCharacterGoods(pchar, iTradeGoods, iQuantityGoods);
			// 
			pchar.quest.generate_trade_quest.win_condition.l1 = "Timer";
			pchar.quest.generate_trade_quest.win_condition.l1.date.day = GetAddingDataDay(0, 1, 0);
			pchar.quest.generate_trade_quest.win_condition.l1.date.month = GetAddingDataMonth(0, 1, 0);
			pchar.quest.generate_trade_quest.win_condition.l1.date.year = GetAddingDataYear(0, 1, 0);
			pchar.quest.generate_trade_quest.win_condition = "generate_trade_quest";
			pchar.quest.generate_trade_quest_progress = "begin";

// KK -->
			Preprocessor_AddQuestData("town", FindTownName(pchar.quest.generate_trade_quest_progress.iTradeColony));
			Preprocessor_AddQuestData("island", FindIslandName(GetIslandIDFromTown(pchar.quest.generate_trade_quest_progress.iTradeColony)));
			Preprocessor_AddQuestData("quantity", iQuantityGoods);
			Preprocessor_AddQuestData("cargo", XI_ConvertString(Goods[iTradeGoods].name));
			Preprocessor_AddQuestData("deadline", GetHumanDate(sti(pchar.quest.generate_trade_quest.win_condition.l1.date.year), sti(pchar.quest.generate_trade_quest.win_condition.l1.date.month), sti(pchar.quest.generate_trade_quest.win_condition.l1.date.day)));
			Preprocessor_AddQuestData("store_owner", pchar.quest.generate_trade_quest_progress.iStoreOwner);
			SetQuestHeader("trade");
			AddQuestRecord("trade", 1);
			Preprocessor_Remove("town");
			Preprocessor_Remove("island"); // PB
			Preprocessor_Remove("quantity");
			Preprocessor_Remove("cargo");
			Preprocessor_Remove("deadline");
			Preprocessor_Remove("store_owner");
// <-- KK
		break;

		case "close_trade_quest":
			DeleteQuestHeader("trade"); // KK
		break;

		case "prepare_for_convoy_quest":
			// PB: Bit more variety -->
			SetModelfromArray(characterFromID("Quest trader"), GetModelIndex(GetRandomModelForTypeExSubCheck(-1, "Upper_Citizens", "man", GetCurrentLocationNation())));
			// PB: Bit more variety <--
			homelocation = pchar.location;
			ChangeCharacterAddressGroup(characterFromID("Quest trader"), homelocation, "reload", "reload1");
			//PlaceCharacter(characterFromID("Quest trader"), "reload");
			iPassenger = rand(5);
			if (iPassenger == PIRATE) iPassenger = HOLLAND;
			characters[GetCharacterIndex("quest trader")].nation = iPassenger;
			SetRandomNameToCharacter(characterFromID("quest trader")); // KK
			pchar.quest.generate_convoy_quest_progress = "begin";
			LAi_SetActorType(characterFromID("Quest trader"));
			LAi_SetActorType(pchar);
			LAi_ActorFollow(pchar, characterFromID("quest trader"), "", 5.0);
			LAi_ActorFollow(characterFromID("quest trader"), pchar, "prepare_for_convoy_quest_2", 5.0);
		break;

		case "prepare_for_convoy_quest_2":
			LAi_SetPlayerType(pchar);
			LAi_ActorDialog(characterFromID("Quest trader"), pchar, "", 10.0, 1.0);
			characters[GetCharacterIndex("quest trader")].dialog.currentnode = "prepare_convoy_quest";
		break;

		case "convoy_refused":
			pchar.quest.generate_convoy_quest.over = "yes";
			pchar.quest.generate_convoy_quest_failed.over = "yes";
			pchar.quest.generate_convoy_quest_completed.over = "yes";
			GetCharacterPos(GetMainCharacter(), &locx, &locy, &locz);
			homelocator = LAi_FindNearestFreeLocator("reload", locx, locy, locz);
			LAi_SetActorType(characterFromID("quest trader"));
			LAi_ActorGoToLocation(characterFromID("quest trader"), "reload", homelocator, "none", "", "", "", 10.0);
		
			if (checkquestattribute("generate_convoy_quest_progress", "completed"))
			{
				iPassenger = makeint(pchar.quest.generate_convoy_quest.convoymoney) + makeint(pchar.rank)*100;
				if(AUTO_SKILL_SYSTEM) { AddPartyExpChar(pchar, "Commerce", iPassenger); }
				else { AddPartyExp(pchar, iPassenger); }
				iPassenger = makeint(pchar.quest.generate_convoy_quest.convoymoney);
				AddMoneyToCharacter(pchar, iPassenger);
				ChangeCharacterReputation(pchar, 1);
				RemoveCharacterCompanion(Pchar, characterFromID("quest trader"));
				pchar.quest.generate_convoy_quest_progress = "";
			}
			if (!checkquestattribute("generate_convoy_quest_progress", "begin"))
			{
				DeleteQuestHeader("convoy"); // KK
			}
			pchar.quest.generate_convoy_quest_progress = "";
			DeleteAttribute(Pchar,"quest.generate_convoy_quest.destination"); // PB
		break;

		case "generate_convoy_quest":
			ChangeCharacterReputation(pchar, -3);
			DoQuestCheckDelay("convoy_failed", 0.0);
		break;

		case "generate_convoy_quest_failed":
			ChangeCharacterReputation(pchar, -5);
			DoQuestCheckDelay("convoy_failed", 0.0);
		break;

		case "convoy_failed":
			RemoveCharacterCompanion(Pchar, characterFromID("quest trader"));
			pchar.quest.generate_convoy_quest_progress = "";
			pchar.quest.generate_convoy_quest.over = "yes";
			pchar.quest.generate_convoy_quest_failed.over = "yes";
			pchar.quest.generate_convoy_quest_completed.over = "yes";
			if (!CheckAttribute(pchar, "quest.generate_convoy_quest.storm") && !CheckAttribute(pchar, "quest.generate_convoy_quest.board") && !CheckAttribute(pchar, "quest.generate_convoy_quest.attack"))
				AddQuestRecord("convoy", 5);
			if (CheckAttribute(pchar, "quest.generate_convoy_quest.storm")) {
				AddQuestRecord("convoy", 2);
				DeleteAttribute(pchar, "quest.generate_convoy_quest.storm");
			}
			if (CheckAttribute(pchar, "quest.generate_convoy_quest.board")) {
				AddQuestRecord("convoy", 3);
				DeleteAttribute(pchar, "quest.generate_convoy_quest.board");
			}
			if (CheckAttribute(pchar, "quest.generate_convoy_quest.attack")) { // KK -->
				Preprocessor_AddQuestData("attacker", pchar.quest.generate_convoy_quest_failed.attack);
				AddQuestRecord("convoy", 4);
				Preprocessor_Remove("attacker"); // <-- KK
				DeleteAttribute(pchar,"quest.generate_convoy_quest.attack");
			}
			CloseQuestHeader("convoy");
		break;

		case "generate_convoy_quest_completed":
			homelocation = pchar.location;
			if(pchar.location == "Antigua_Port")	// PB: Weird pier needs special case
				ChangeCharacterAddressGroup(CharacterFromID("quest trader"), pchar.location, "reload", "reload2");
			else
				SetCharacterToNearLocatorFromMe("quest trader", 3); // PB
			LAi_SetActorType(characterFromID("quest trader"));
			LAi_SetActorType(pchar);
			LAi_ActorFollow(pchar, characterFromID("quest trader"), "", -1);
			LAi_ActorFollow(characterFromID("quest trader"), pchar, "generate_convoy_quest_completed_2", -1);
		break;

		case "generate_convoy_quest_completed_2":
			LAi_type_actor_Reset(pchar);
			LAi_ActorWaitDialog(pchar, characterFromID("quest trader"));
			LAi_ActorDialog(characterFromID("quest trader"), pchar, "player_back", 2.0, 1.0);
			characters[GetCharacterIndex("quest trader")].dialog.currentnode = "complete_convoy_quest";
			pchar.quest.generate_convoy_quest_progress = "completed";
		break;

		case "convoy_agreeded":
			SetCompanionIndex(Pchar, -1, GetCharacterIndex("quest trader"));
			SetCharacterRemovable(characterFromID("quest trader"), false);
			
			// KK GetCharacterPos(GetMainCharacter(), &locx, &locy, &locz);
			// KK homelocator = LAi_FindNearestFreeLocator("reload", locx, locy, locz);
			LAi_SetActorType(characterFromID("quest trader"));
			LAi_ActorGoToLocation(characterFromID("quest trader"), "reload", LocatorExitSence(PChar.location, "from", "house"), "none", "", "", "", -1);

			string sdest = "";
			string sIsland = pchar.quest.generate_convoy_quest.island;
			string sDestin = XI_ConvertString("seaport");
			for(int di=sti(Locations[0].IslandsList.(sIsland).begin); di<sti(Locations[0].IslandsList.(sIsland).end); di++)
			{
				if(CheckAttribute(&locations[di],"townsack") && locations[di].townsack==pchar.quest.generate_convoy_quest.destination)
				{
					if(CheckAttribute(&locations[di],"id") && HasSubStr(locations[di].id,"port"))
					{
						sdest = locations[di].id;
						break;
					}
				}
				else
				{
					switch(sIsland)
					{
						case DEFAULT_TRADEISLAND: sdest = "Conceicao_shore_02"; break;
					}
					if(sdest!="") break;
				}
			}

			if(FindLocation(sdest)!=-1) sDestin = TranslateString("",locations[FindLocation(sdest)].id.label);
			if(sIsland!="Conceicao" && !HasSubStr(sDestin,XI_ConvertString("SeaPort")))
			{
				sDestin = TranslateString(pchar.quest.generate_convoy_quest.destination, "SeaPort");
			}

// KK -->
			Preprocessor_AddQuestData("island", FindIslandName(GetIslandIDFromTown(pchar.quest.generate_convoy_quest.destination)));
			Preprocessor_AddQuestData("destination", FindTownName(pchar.quest.generate_convoy_quest.destination));
			Preprocessor_AddQuestData("money", pchar.quest.generate_convoy_quest.convoymoney); // PB
			SetQuestHeader("convoy");
			AddQuestRecord("convoy", 1);
			Preprocessor_Remove("island");
			Preprocessor_Remove("destination");
			Preprocessor_Remove("money"); // PB
// <-- KK
			characters[GetCharacterIndex("quest trader")].dialog.currentnode = "convoy_in_progress"; // PB: Prevent 'gibberish' in his cabin
			character_SetCompanionEnemyEnable(characterFromID("quest trader"), true);
			pchar.quest.generate_convoy_quest_completed.win_condition.l1 = "Location";
			pchar.quest.generate_convoy_quest_completed.win_condition.l1.location = sDest;
			pchar.quest.generate_convoy_quest_completed.win_condition = "generate_convoy_quest_completed";
		break;

		case "prepare_gen_convoy_quest":
			GenerateConvoyQuest();
			characters[GetCharacterIndex("quest trader")].dialog.currentnode = "prepare_convoy_quest_4";
			LAi_ActorDialog(characterfromID("quest trader"), pchar, "", 1.0, 1.0);
		break;

//boal -->
		case "kill_pirate_agree":
			pchar.quest.prepare_for_kill_pirate.win_condition.l1 = "location";
			pchar.quest.prepare_for_kill_pirate.win_condition.l1.location = pchar.quest.generate_kill_quest.destination;
			pchar.quest.prepare_for_kill_pirate.win_condition = "prepare_for_kill_pirate";
			pchar.quest.prepare_for_kill_pirate.town = GetCurrentTownID();
			// 
			//Log_SetStringToLog("kill_pirate_agree");
// KK -->
			Preprocessor_AddQuestData("island", TranslateString("", FindIslandName(pchar.quest.generate_kill_quest.destination)));
			Preprocessor_AddQuestData("ship_descr", GetShipDescribe("Quest pirate", true, true, true, true));
			SetQuestHeader("hunting");
			AddQuestRecord("hunting", 1);
			Preprocessor_Remove("island");
			Preprocessor_Remove("ship_descr");
// <-- KK
		break;

		case "prepare_for_kill_pirate":
			//NK, use fantom calls way up top.
			Group_AddCharacter("Story_Pirate", "Quest pirate");
			//Log_SetStringToLog("prepare_for_kill_pirate");
			Group_SetGroupCommander("Story_Pirate", "Quest pirate");
			Group_SetTaskAttack("Story_Pirate", PLAYER_GROUP);
			//Group_SetAddress("Story_Pirate", Characters[GetMainCharacterIndex()].location, "Quest_ships", "Quest_ship_3");
			Group_SetAddress("Story_Pirate", Pchar.location, "Quest_ships", GetRandomQuestShipLocator(pchar.location)); // PB: Add some variety

			Group_LockTask("Story_Pirate");

			pchar.quest.kill_pirate_complete.win_condition.l1 = "NPC_Death";
			pchar.quest.kill_pirate_complete.win_condition.l1.character = "Quest pirate";
			pchar.quest.kill_pirate_complete.win_condition = "kill_pirate_complete";
		break;

		case "kill_pirate_complete":
			if(!CheckAttribute(pchar,"quest.generate_kill_quest")) break;//MAXIMUS
			if(pchar.quest.generate_kill_quest=="completed") break;//MAXIMUS
			pchar.quest.generate_kill_quest = "completed";
// KK -->
			if (sti(Pchar.quest.generate_kill_quest.nation) == PIRATE)
				Preprocessor_AddQuestData("type", XI_ConvertString("1Pirate"));
			else
				Preprocessor_AddQuestData("type", XI_ConvertString(GetNationDescByType(sti(pchar.quest.generate_kill_quest.nation))) + " " + XI_ConvertString("Corsair"));
			cc = 0;
			for (iColony = 1; iColony <= GetIslandTownsQuantity(pchar.quest.generate_kill_quest.destination); iColony++) {
				if (GetTownGovernorIndex(GetTownIDFromIsland(pchar.quest.generate_kill_quest.destination, iColony)) != -1) cc++;
			}
			if (cc > 1)
				Preprocessor_AddQuestData("town", FindTownName(PChar.quest.generate_kill_quest.town) + " " + TranslateString("", "on") + " " + FindIslandName(pchar.quest.generate_kill_quest.destination));
			else
				Preprocessor_AddQuestData("town", FindTownName(PChar.quest.generate_kill_quest.town));
			Preprocessor_AddQuestData("ship_descr", GetShipDescribe("Quest pirate", true, true, true, true));
			AddQuestRecord("hunting", rand(4) + 2);
			Preprocessor_Remove("type");
			Preprocessor_Remove("town");
			Preprocessor_Remove("ship_descr");
// <-- KK
		break;

		case "kill_pirate_refused":
			pchar.quest.kill_pirate_refused_timer.win_condition.l1 = "Timer";
			pchar.quest.kill_pirate_refused_timer.win_condition.l1.date.day = GetAddingDataDay(0, 0, 3);
			pchar.quest.kill_pirate_refused_timer.win_condition.l1.date.month = GetAddingDataMonth(0, 0, 3);
			pchar.quest.kill_pirate_refused_timer.win_condition.l1.date.year = GetAddingDataYear(0, 0, 3);
			pchar.quest.kill_pirate_refused_timer.win_condition = "kill_pirate_refused_timer";
		break;

		case "kill_pirate_refused_2":
			//Log_SetStringToLog("kill_pirate_refused_2");
			pchar.quest.kill_pirate_refused_timer.win_condition.l1 = "Timer";
			pchar.quest.kill_pirate_refused_timer.win_condition.l1.date.day = GetAddingDataDay(0, 0, 3);
			pchar.quest.kill_pirate_refused_timer.win_condition.l1.date.month = GetAddingDataMonth(0, 0, 3);
			pchar.quest.kill_pirate_refused_timer.win_condition.l1.date.year = GetAddingDataYear(0, 0, 3);
			pchar.quest.kill_pirate_refused_timer.win_condition = "kill_pirate_refused_timer";
			DeleteQuestHeader("hunting");
			DeleteQuestAttribute("hunting");
		break;

		case "kill_pirate_refused_timer":
			//Log_SetStringToLog("kill_pirate_refused_timer");
			DeleteAttribute(pchar, "quest.generate_kill_quest");
			//pchar.quest.generate_kill_quest = "";
		break;
// boal <--

		case "sleep_in_tavern":
//			RecalculateJumpTable();
//			DoQuestReloadToLocation(pchar.location + "_upstairs", "goto", "goto2", "restore_hp");
			string roomName = pchar.location;//MAXIMUS -->
			aref cLoctr; makearef(cLoctr,locations[FindLocation(pchar.location)].reload);
			for(int h=0; h<GetAttributesNum(cLoctr); h++)
			{
				aref curItem = GetAttributeN(cLoctr,h);
				string attrName = GetAttributeName(curItem);
				if(CheckAttribute(cLoctr,attrName+".go"))
				{
					if(HasSubStr(cLoctr.(attrName).go,"_upstairs") || HasSubStr(cLoctr.(attrName).go,"_bedroom")) roomName = cLoctr.(attrName).go;
				}
			}
			// Philippe: For Eleuthera -->
			if(CheckAttribute(pchar,"reloadto"))
			{
				homelocator = pchar.reloadto;
				if(HasSubStr(homelocator,"reload")) homegroup = "reload";
				else homegroup = "goto";
				DeleteAttribute(pchar,"reloadto");
			}
			else
			{
				homelocator = "goto2";
				homegroup = "goto";
			}
			// Philippe: For Eleuthera <--
			DoQuestReloadToLocation(roomName, homegroup, homelocator, "restore_hp");//MAXIMUS <--
		break;

		case "restore_hp":
			LAi_SetCurHPMax(pchar);
			for (i = 1; i < 4; i++)
			{
				iOfficer = GetOfficersIndex(Pchar, "" + i);
				if (iOfficer != -1) LAi_SetCurHPMax(&characters[iOfficer]);
			}
		break;

		case "drink_talk_with_soldier":
			tavernfriend = pchar.quest.friend_in_tavern;
			LAi_SetSitType(characterFromID(tavernfriend));
			switch(pchar.location)
			{
				case "Redmond_tavern":
					LAi_SetHP(characterFromID("Redmond soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Redmond Soldier"), "Redmond_town_01", "cityzen9");
					DoQuestReloadToLocation("Redmond_town_01", "goto", "goto12", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("Redmond Soldier"), "ENGLAND_SOLDIERS");
					pchar.friend_in_tavern2 = "ENGLAND_SOLDIERS";
				break;

				case "Oxbay_tavern":
					LAi_SetHP(characterFromID("Oxbay soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Oxbay Soldier"), "Oxbay_town", "goto37");
					DoQuestReloadToLocation("Oxbay_town", "goto", "goto36", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("Oxbay Soldier"), "ENGLAND_SOLDIERS");
					pchar.friend_in_tavern2 = "ENGLAND_SOLDIERS";
				break;

				case "Greenford_tavern":
					LAi_SetHP(characterFromID("Greenford soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Greenford Soldier"), "Greenford_town", "goto9");
					DoQuestReloadToLocation("Greenford_town", "goto", "goto14", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("Greenford Soldier"), "ENGLAND_SOLDIERS");
					pchar.friend_in_tavern2 = "ENGLAND_SOLDIERS";
				break;

				case "Falaise_De_Fleur_tavern":
					LAi_SetHP(characterFromID("Falaise de Fleur soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Falaise De Fleur Soldier"), "Falaise_de_fleur_location_03", "locator12");
					DoQuestReloadToLocation("Falaise_De_fleur_location_03", "goto", "locator11", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("Falaise De Fleur Soldier"), "FRANCE_SOLDIERS");
					pchar.friend_in_tavern2 = "FRANCE_SOLDIERS";
				break;

				case "Muelle_tavern":
					LAi_SetHP(characterFromID("Muelle soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Muelle Soldier"), "Muelle_town_01", "goto23");
					DoQuestReloadToLocation("Muelle_town_01", "goto", "goto100", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("Muelle Soldier"), "SPAIN_SOLDIERS");
					pchar.friend_in_tavern2 = "SPAIN_SOLDIERS";
				break;

				case "Douwesen_tavern":
					LAi_SetHP(characterFromID("Douwesen soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Douwesen Soldier"), "Douwesen_town", "goto3");
					DoQuestReloadToLocation("Douwesen_town", "goto", "goto5", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("DOuwesen Soldier"), "DOUWESEN_SOLDIERS");
					pchar.friend_in_tavern2 = "DOUWESEN_SOLDIERS";
				break;

				case "Pirate_tavern":
					LAi_SetHP(characterFromID("Pirate soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Pirate Soldier"), "Pirate_fort", "character9");
					DoQuestReloadToLocation("Pirate_fort", "goto", "character10", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("Pirate Soldier"), "PIRATE_SOLDIERS");
					pchar.friend_in_tavern2 = "PIRATE_SOLDIERS";
				break;

				case "Conceicao_tavern":
					LAi_SetHP(characterFromID("Conceicao soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Conceicao Soldier"), "Conceicao_town", "goto5");
					DoQuestReloadToLocation("Conceicao_town", "goto", "goto4", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("Conceicao Soldier"), "CONCEICAO_SOLDIERS");
					pchar.friend_in_tavern2 = "CONCEICAO_SOLDIERS";
				break;

				case "Smugglers_tavern":
					LAi_SetHP(characterFromID("Smugglers soldier"), 80.0, 80.0);
					ChangeCharacterAddress(characterFromID("Smugglers Soldier"), "Smugglers_lair", "goto12");
					DoQuestReloadToLocation("Smugglers_lair", "goto", "goto11", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("Smugglers Soldier"), "SMUGGLER_SOLDIERS");
					pchar.friend_in_tavern2 = "SMUGGLER_SOLDIERS";
				break;

				case "QC_tavern":
					LAi_SetHP(characterFromID("QC soldier"), 80.0, 80.0);
					DoQuestReloadToLocation("QC_town", "goto", "character4", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("QC Soldier"), "QC_SOLDIERS");
					pchar.friend_in_tavern2 = "QC_SOLDIERS";
				break;

				case "QC_brothel"://<<<<-------------------------------------------------------------------added here, love verruckt
					LAi_SetHP(characterFromID("QC soldier"), 80.0, 80.0);
					DoQuestReloadToLocation("QC_town", "goto", "character4", "drink_speak_with_soldier");
					LAi_group_MoveCharacter(characterFromID("QC Soldier"), "QC_SOLDIERS");
					pchar.friend_in_tavern2 = "QC_SOLDIERS";
				break;
			}
		break;

		case "drink_speak_with_soldier":
			LAi_SetActorType(pchar);
			switch(pchar.location)
			{
				case "Redmond_town_01":
					characters[GetCharacterIndex("Redmond soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Redmond soldier"), "player_back", 5.0, 1.0);
				break;

				case "Oxbay_town":
					characters[GetCharacterIndex("Oxbay soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Oxbay Soldier"), "player_back", 5.0, 1.0);
				break;

				case "Greenford_town":
					characters[GetCharacterIndex("Greenford soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Greenford soldier"), "player_back", 5.0, 1.0);
				break;

				case "Falaise_De_Fleur_town":
					characters[GetCharacterIndex("Falaise De Fleur soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Falaise De Fleur soldier"), "player_back", 5.0, 1.0);
				break;

				case "Muelle_town_01":
					characters[GetCharacterIndex("Muelle soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Muelle soldier"), "player_back", 5.0, 1.0);
				break;

				case "Douwesen_town":
					characters[GetCharacterIndex("Douwesen Soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Douwesen Soldier"), "player_back", 5.0, 1.0);
				break;

				case "Pirate_town":
					characters[GetCharacterIndex("Pirate Soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Pirate Soldier"), "player_back", 5.0, 1.0);
				break;

				case "Conceicao_town":
					characters[GetCharacterIndex("Conceicao Soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Conceicao Soldier"), "player_back", 5.0, 1.0);
				break;

				case "Smugglers_town":
					characters[GetCharacterIndex("Smugglers Soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("Smugglers Soldier"), "player_back", 5.0, 1.0);
				break;

				case "QC_town":
					PlaceCharacter(characterFromID("QC Soldier"), "goto");
					characters[GetCharacterIndex("QC Soldier")].dialog.currentnode = "drink";
					LAi_ActorDialog(pchar, characterFromID("QC Soldier"), "player_back", 5.0, 1.0);
				break;
			}
		break;

		//ASVS moved it here
		case "fight_with_soldier_for_drink":
			LAi_group_FightGroups(pchar.friend_in_tavern2, LAI_GROUP_PLAYER, true);
		break;

		case "without_memory":
			LAi_Fade("exit_sit_2", "saved_by_off");
		break;

		case "drink_fight_in_tavern_with_fantoms":
			LAi_Fade("exit_sit_2", "fighting2");
		break;

		case "fighting":
			/*NK*/ sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "man1", "reload", "reload1");
			sld.headmodel = "h_man1";
			sld.dialog.filename = "tavern fightingman_dialog.c";

			LAi_SetActorType(sld);
			LAi_group_MoveCharacter(sld, "TAVERN_FIGHTER");
			LAi_ActorDialogNow(sld, pchar, "", -1);
		break;

		case "fighting2":
			locCameraFollow();
			LAi_SetSitType(characterFromID(pchar.quest.friend_in_tavern));
			LAi_SetPlayerType(pchar);
			LAi_LocationFightDisable(&Locations[FindLocation(pchar.location)], false);

			LAi_group_FightGroups("TAVERN_FIGHTER", LAI_GROUP_PLAYER, true);
			LAi_group_SetCheck("TAVERN_FIGHTER", "kill_tavern_fightman_complete");
		break;

		///////////////////////////////////////////////////////////////
		// Quest Line Rescue Girls
		///////////////////////////////////////////////////////////////
// added by MAXIMUS 18.11.2006 [for nice show of this process] -->
		case "go_to_see_girl":
			LAi_Fade("go_to_room", "");
			LAi_SetActorType(Pchar);
		break;

		case "go_to_room":
			string offLocat = "";
			string offGroup = "";
			offLocat = LAi_FindIndexedLocator(Pchar.location, "goto","goto");
			if(offLocat!="" && offLocat!=Pchar.location.locator) { offGroup = "goto"; }
			else
			{
				offLocat = LAi_FindIndexedLocator(Pchar.location, "rld","loc");
				if(offLocat!="" && offLocat!=Pchar.location.locator) { offGroup = "rld"; }
				else
				{
					offLocat = LAi_FindIndexedLocator(Pchar.location, "officers","reload");
					if(offLocat!="" && offLocat!=Pchar.location.locator) { offGroup = "officers"; }
					else
					{
						offLocat = LAi_FindIndexedLocator(Pchar.location, "reload","reload");
						if(offLocat!="" && offLocat!=Pchar.location.locator) { offGroup = "reload"; }
						else { offLocat = ""; offGroup = ""; }
					}
				}
			}
			LAi_ClearIndexedLocators(Pchar.location, offGroup);
			if(offLocat!="") { ChangeCharacterAddressGroup(characterFromID(Pchar.quest.friend_in_tavern), Pchar.location, offGroup, offLocat); }
			LAi_SetActorType(characterFromID(Pchar.quest.friend_in_tavern));
			LAi_ActorTurnToCharacter(Pchar, CharacterFromID(Pchar.quest.friend_in_tavern));
			string neededLocator = "";
			string neededID = "None";
			for(int rel=1; rel<10; rel++)
			{
				string relName = "l"+rel;
				if(CheckAttribute(locations[FindLocation(Pchar.location)],"reload."+relName+".go"))
				{
					neededID = locations[FindLocation(Pchar.location)].reload.(relName).go;
					if(HasSubStr(neededID,"_upstairs"))
					{
						neededLocator = locations[FindLocation(Pchar.location)].reload.(relName).name;
					}
				}
			}
			LAi_ActorGoToLocator(CharacterFromID(Pchar.quest.friend_in_tavern), "reload", neededLocator, "go_to_see_girl_1", -1);
			if(AlwaysRunToggle)
			{
				AlwaysRunToggle = false;
				BeginChangeCharacterActions(GetMainCharacter());
				SetDefaultNormWalk(GetMainCharacter());
				SetDefaultFight(GetMainCharacter());
				EndChangeCharacterActions(GetMainCharacter());
			}
			LAi_ActorFollow(pchar, characterFromID(Pchar.quest.friend_in_tavern), "", -1);
		break;

		case "go_to_see_girl_1":
			ChangeCharacterAddressGroup(characterFromID(Pchar.quest.friend_in_tavern), "None", "", "");
			Lai_QuestDelay("to_the_room_for_see_girl", 1.0);
		break;
// added by MAXIMUS 18.11.2006 [for nice show of this process] <--

		case "to_the_room_for_see_girl":
			locations[FindLocation(pchar.location + "_upstairs")].reload.l1.disable = 1;
			DoQuestReloadToLocation(pchar.location + "_upstairs", "reload", "reload1", "to_the_girl");// changed by MAXIMUS 18.11.2006 [for nice show of this process]
		break;

// changed by MAXIMUS 18.11.2006 [for nice show of this process] -->
		case "to_the_girl":
			LAi_SetActorType(pchar);
			LAi_type_actor_Reset(pchar);
			LAi_SetActorType(characterFromID(pchar.quest.friend_in_tavern));
			LAi_SetActorType(characterFromID("Virginie d'Espivant"));
			string freelocator = LAi_FindIndexedLocator(pchar.location, "goto", "goto");
			ChangeCharacterAddressGroup(characterFromID(pchar.quest.friend_in_tavern), pchar.location, "goto", LAi_FindIndexedLocator(pchar.location, "goto", "goto"));
			ChangeCharacterAddressGroup(characterFromID("Virginie d'Espivant"), pchar.location, "goto", LAi_FindIndexedLocator(pchar.location, "goto", "goto"));
			LAi_ActorGoToLocator(characterFromID("Virginie d'Espivant"), "goto", freelocator, "", 6.0);
			LAi_ActorGoToLocator(Pchar, "goto", characters[GetCharacterIndex("Virginie d'Espivant")].location.locator, "to_the_room_for_see_girl_2", 6.0);
		break;

		case "to_the_room_for_see_girl_2":
			LAi_SetPlayerType(pchar);
			if(!AlwaysRunToggle)
			{
				AlwaysRunToggle = true;
				BeginChangeCharacterActions(GetMainCharacter());
				SetDefaultNormWalk(GetMainCharacter());
				SetDefaultFight(GetMainCharacter());
				EndChangeCharacterActions(GetMainCharacter());
			}
			LAi_ClearIndexedLocators(Pchar.location, "goto");
			LAi_SetStayType(characterFromID("Virginie d'Espivant"));
// changed by MAXIMUS 18.11.2006 [for nice show of this process] <--
			LAi_ActorDialog(characterFromID(pchar.quest.friend_in_tavern), pchar, "", 2.0, 1.0);
		break;

		case "fight_in_upstairs_for_girl":
			LAi_SetFightMode(PChar, true);// MAXIMUS: prepared for fight
			GiveItem2Character(CharacterFromId(pchar.quest.friend_in_tavern), "blade5");
			EquipCharacterByItem(CharacterFromId(pchar.quest.friend_in_tavern), "blade5");
			LAi_LocationFightDisable(&Locations[FindLocation(pchar.location)], 0);
			LAi_ActorAttack(characterFromID(pchar.quest.friend_in_tavern), pchar, "");
			pchar.quest.kill_man_in_upstairs_for_girl.win_condition.l1 = "NPC_Death";
			pchar.quest.kill_man_in_upstairs_for_girl.win_condition.l1.character = pchar.quest.friend_in_tavern;
			pchar.quest.kill_man_in_upstairs_for_girl.win_condition = "kill_man_in_upstairs_for_girl";
		break;

		case "kill_man_in_upstairs_for_girl":
			LAi_LocationFightDisable(&Locations[FindLocation(pchar.location)], 0);
			LAi_SetFightMode(pchar, false);
			pchar.quest.gambling_with_girl = "gambled";
			LAi_SetActorType(characterFromID("Virginie d'Espivant"));
			LAi_ActorDialog(characterFromID("Virginie d'Espivant"), pchar, "open_room", 2.0, 1.0);
		break;
		
		case "open_room":
			locations[FindLocation(pchar.location)].reload.l1.disable = 0;// MAXIMUS: was pchar.location + "_upstairs", WHY?
		break;

		case "girl_for_sale":
			LAi_type_actor_Reset(CharacterFromID("Virginie d'Espivant"));
			ChangeCharacterAddress(CharacterFromID("Virginie d'Espivant"), "none", "none");/*
			PostEvent("CheckQuestPossibility", 100, "1", 0);
			pchar.quest.not_to_the_ship_2.win_condition.l1 = "ExitFromLocation";
			pchar.quest.not_to_the_ship_2.win_condition.l1.location = pchar.location;
			pchar.quest.not_to_the_ship_2.win_condition = "girl_for_sale_2";*///MAXIMUS: moved to MAXIMUS_Functions.c
		break;

		case "girl_for_sale_2":
			LAi_SetHP(characterFromID("danielle_quests_corsair_1"), 80.0, 80.0);
			ChangeCharacterAddressGroup(characterFromID("danielle_quests_corsair_1"), pchar.location, "reload", "reload1");
			LAi_SetActorType(characterFromID("danielle_quests_corsair_1"));
			LAi_ActorDialog(characterFromID("danielle_quests_corsair_1"), pchar, "", 2.0, 1.0);
		break;

		case "habitue_exit_from_room":
			LAi_ActorGoToLocator(characterFromID(pchar.quest.friend_in_tavern), "reload", "reload1", "habitue_exit_from_room_2_complete", 4.0);
			LAi_SetActorType(characterFromID("Virginie d'Espivant"));
			LAi_ActorDialog(characterFromID("Virginie d'Espivant"), pchar, "open_room", 2.0, 1.0);
		break;

		case "girl_exit_from_room":
			pchar.quest.cure_bag_girl_exit_from_room_2.win_condition.l1 = "ExitFromLocation";
			pchar.quest.cure_bag_girl_exit_from_room_2.win_condition.l1.location = pchar.location;
			pchar.quest.cure_bag_girl_exit_from_room_2.win_condition = "girl_exit_from_room_2_complete";

			LAi_ActorGoToLocator(characterFromID("Virginie d'Espivant"), "reload", "reload1", "girl_exit_from_room_2_complete", 4.0);
		break;

		case "girl_exit_from_room_2_complete":
			LAi_type_actor_Reset(CharacterFromID("Virginie d'Espivant"));
			if(AUTO_SKILL_SYSTEM) { AddPartyExpChar(pchar, "Leadership", 5000); }
			else { AddPartyExp(pchar, 5000); }
			pchar.quest.gambling_with_girl = "done";
			ChangeCharacterAddress(CharacterFromID("Virginie d'Espivant"), "none", "none");
		break;

		case "habitue_exit_from_room_2_complete":
			switch(pchar.location)
			{
				case "Oxbay_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Oxbay_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "Greenford_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Greenford_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "Redmond_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Redmond_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "Muelle_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Muelle_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "Douwesen_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Douwesen_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "Conceicao_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Conceicao_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "Smugglers_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Smugglers_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "Pirate_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Pirate_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "QC_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "QC_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;

				case "Falaise_de_fleur_tavern_upstairs":
					ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], "Falaise_De_fleur_tavern", "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);
				break;
				ChangeCharacterAddressGroup(&characters[getCharacterIndex(pchar.quest.friend_in_tavern)], strcut(pchar.location,0,strlen(pchar.location)-10), "sit", characters[getCharacterIndex(pchar.quest.friend_in_tavern)].quest.locator);// added by MAXIMUS for new islands
			}
			LAi_SetSitType(characterFromID(pchar.quest.friend_in_tavern));
		break;

		case "gambled_girl_to_FdF"://MAXIMUS: -->
			LAi_type_actor_Reset(CharacterFromID("Virginie d'Espivant"));
			AddPassenger(pchar, CharacterFromID("Virginie d'Espivant"), 0);
			SetCharacterRemovable(characterFromID("Virginie d'Espivant"), false);
			if(GetCharacterShipCabin(pchar)!="Cabin_none")
			{
				ChangeCharacterAddressGroup(characterFromID("Virginie d'Espivant"), GetCharacterShipCabin(pchar), "goto", "goto1");
				characters[GetCharacterIndex("Virginie d'Espivant")].chr_ai.type = LAI_TYPE_CITIZEN;
				SetEventHandler("CharacterTypeUpdate","LAi_CharacterTypeUpdate",1);
				PostEvent("CharacterTypeUpdate",3000,"s","Virginie d'Espivant");
			}
			else ChangeCharacterAddress(CharacterFromID("Virginie d'Espivant"), "none", "none");//MAXIMUS: <--
			OfficersReaction("good");
			pchar.quest.gambling_with_girl = "to_FDF";
			pchar.quest.gambled_girl_comes_to_FDF_tavern.win_condition.l1 = "location";
			pchar.quest.gambled_girl_comes_to_FDF_tavern.win_condition.l1.location = "Falaise_De_fleur_tavern";
			pchar.quest.gambled_girl_comes_to_FDF_tavern.win_condition = "gambled_girl_comes_to_FDF_tavern_complete";
			Locations[FindLocation("Falaise_De_Fleur_tavern")].reload.l1.disable = 1;
			Locations[FindLocation(pchar.location)].reload.l1.disable = 0;
		break;

		case "gambled_girl_comes_to_FDF_tavern_complete":
			ChangeCharacterAddress(characterFromID("Raymond Bouchez"), "Falaise_De_Fleur_Tavern", "goto4");
			ChangeCharacterAddress(characterFromID("Virginie d'Espivant"), "Falaise_De_Fleur_Tavern", "goto5");
			
			LAi_SetActorType(characterFromID("Virginie d'Espivant"));
			LAi_SetActorType(characterFromID("Falaise_De_Fleur_officiant"));
			LAi_SetActorType(characterFromID("Raymond Bouchez"));
			LAi_SetActorType(pchar);
			//LAi_ActorTurnToCharacter(characterFromID("Raymond Bouchez"), characterFromID("Falaise_De_Fleur_officiant"));
			LAi_ActorFollow(pchar, characterFromID("Raymond Bouchez"), "", 2.0);
			LAi_ActorFollow(characterFromID("Virginie d'Espivant"), characterFromID("Raymond Bouchez"), "gambled_girl_comes_to_FDF_tavern_2_complete", 2.0);
			LAi_ActorFollow(characterFromID("Falaise_De_Fleur_officiant"), characterFromID("Raymond Bouchez"), "", 3.0);
		break;

		case "gambled_girl_comes_to_FDF_tavern_2_complete":
			LAi_type_actor_Reset(pchar);
			LAi_type_actor_Reset(characterFromID("Raymond Bouchez"));
			LAi_ActorWaitDialog(pchar, characterFromID("Raymond Bouchez"));
			LAi_ActorDialog(characterFromID("Raymond Bouchez"), pchar, "", 2.0, 1.0);
		break;

		case "virginie_speak":
			LAi_QuestDelay("virginie_speak_2", 0.3);
		break;

		case "virginie_speak_2":
			LAi_type_actor_Reset(pchar);
			LAi_type_actor_Reset(characterFromID("Virginie d'Espivant"));
			LAi_ActorWaitDialog(pchar, characterFromID("Virginie d'Espivant"));
			LAi_ActorDialog(characterFromID("Virginie d'Espivant"), pchar, "", 2.0, 1.0);
		break;

		case "Raymond_speak":
			LAi_QuestDelay("Raymond_speak_2", 0.3);
		break;

		case "Raymond_speak_2":
			LAi_type_actor_Reset(pchar);
			LAi_type_actor_Reset(characterFromID("Raymond Bouchez"));
			LAi_ActorWaitDialog(pchar, characterFromID("Raymond Bouchez"));
			LAi_ActorDialog(characterFromID("Raymond Bouchez"), pchar, "", 2.0, 1.0);
		break;

		case "sister_speak":
			LAi_QuestDelay("sister_speak_2", 0.3);
		break;

		case "sister_speak_2":
			LAi_type_actor_Reset(pchar);
			LAi_type_actor_Reset(characterFromID("Falaise_De_Fleur_officiant"));
			LAi_ActorWaitDialog(pchar, characterFromID("Falaise_De_Fleur_officiant"));
			LAi_ActorDialog(characterFromID("Falaise_De_Fleur_officiant"), pchar, "", 2.0, 1.0);
		break;

		case "gambled_girl_exit_from_FDF_tavern":
			if(AUTO_SKILL_SYSTEM) { AddPartyExpChar(pchar, "Leadership", 5000); }
			else { AddPartyExp(pchar, 5000); }
			LAi_SetCitizenType(characterFromID("Falaise_De_Fleur_officiant"));
			LAi_SetActorType(pchar);
			LAi_ActorGoToLocator(pchar, "reload", "reload1", "gambled_girl_exit_from_tavern_complete", 3.0);
		break;

		case "gambled_girl_exit_from_tavern_complete":
			DoQuestReloadToLocation("Falaise_de_fleur_location_03", "reload", "Falaise_de_fleur_tavern", "last_speak_with_virginia");
			characters[GetCharacterIndex("Raymond Bouchez")].location = "none";
			Locations[FindLocation("Falaise_De_Fleur_tavern")].reload.l1.disable = 0;
		break;

		case "last_speak_with_virginia":
			pchar.quest.gambling_with_girl = "to_hovernor";
			Locations[FindLocation("Falaise_De_Fleur_location_03")].reload.l3.disable = 0; //NK so you can see the governor to return her even if Oxbay hasn't been recaptured.
			ChangeCharacterAddress(characterFromID("Virginie d'Espivant"), "Falaise_de_fleur_location_03", "locator9");
			LAi_SetPlayerType(pchar);
			LAi_type_actor_Reset(characterFromID("Virginie d'Espivant"));
			LAi_ActorDialog(characterFromID("Virginie d'Espivant"), pchar, "", 2.0, 1.0);
			characters[getCharacterIndex("joseph claude le moigne")].dialog.currentnode = "quests";
		break;

		case "remove_virginie_complete":
			RemovePassenger(pchar, characterFromID("Virginie d'Espivant"));
		break;

		///////////////////////////////////////////////////////////////
		// Quest Line Rescue Girls
		///////////////////////////////////////////////////////////////

		case "saved_by_off":
			LAi_SetStayType(pchar);
			AddMoneyToCharacter(pchar, -100);
			homelocation = pchar.location;
			switch(homelocation)
			{
				case "Redmond_tavern":
					PlaceCharacter(characterFromID("Redmond_officiant"), "goto");
					characters[GetCharacterIndex("Redmond_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Redmond_officiant"));
					LAi_ActorDialog(characterFromID("Redmond_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "Oxbay_tavern":
					PlaceCharacter(characterFromID("Oxbay_officiant"), "goto");
					characters[GetCharacterIndex("Oxbay_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Oxbay_officiant"));
					LAi_ActorDialog(characterFromID("Oxbay_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "Greenford_tavern":
					PlaceCharacter(characterFromID("Greenford_officiant"), "goto");
					characters[GetCharacterIndex("Greenford_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Greenford_officiant"));
					LAi_ActorDialog(characterFromID("Greenford_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "Falaise_De_Fleur_tavern":
					PlaceCharacter(characterFromID("Falaise_De_Fleur_officiant"), "goto");
					characters[GetCharacterIndex("Falaise_De_Fleur_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Falaise_De_fleur_officiant"));
					LAi_ActorDialog(characterFromID("Falaise_de_fleur_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "Muelle_tavern":
					PlaceCharacter(characterFromID("Muelle_officiant"), "goto");
					characters[GetCharacterIndex("Muelle_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Muelle_officiant"));
					LAi_ActorDialog(characterFromID("Muelle_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "Douwesen_tavern":
					PlaceCharacter(characterFromID("Douwesen_officiant"), "goto");
					characters[GetCharacterIndex("Douwesen_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Douwesen_officiant"));
					LAi_ActorDialog(characterFromID("Douwesen_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "Pirate_tavern":
					PlaceCharacter(characterFromID("Pirate_officiant"), "goto");
					characters[GetCharacterIndex("Pirate_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Pirate_officiant"));
					LAi_ActorDialog(characterFromID("Pirate_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "Conceicao_tavern":
					PlaceCharacter(characterFromID("Conceicao_officiant"), "goto");
					characters[GetCharacterIndex("Conceicao_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Conceicao_officiant"));
					LAi_ActorDialog(characterFromID("Conceicao_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "Smugglers_tavern":
					PlaceCharacter(characterFromID("Smugglers_officiant"), "goto");
					characters[GetCharacterIndex("Smugglers_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("Smugglers_officiant"));
					LAi_ActorDialog(characterFromID("Smugglers_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "QC_tavern":
					PlaceCharacter(characterFromID("QC_officiant"), "goto");
					characters[GetCharacterIndex("QC_officiant")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("QC_officiant"));
					LAi_ActorDialog(characterFromID("QC_officiant"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;

				case "QC_brothel"://<<<----------------------------------------------------------------Added here, love verruckt
					PlaceCharacter(characterFromID("wench2"), "goto");
					characters[GetCharacterIndex("wench2")].dialog.currentnode = "without_money";
					LAi_SetActorType(characterFromID("wench2"));
					LAi_ActorDialog(characterFromID("wench2"), pchar, "officiant_back_to_citizen", 5.0, 1.0);
				break;
			}
		break;

		case "officiant_back_to_citizen":
			LAi_SetPlayerType(pchar);
			AddMoneyToCharacter(pchar, -100);
			switch(pchar.location)
			{
				case "Redmond_tavern":
					LAi_SetWaitressType(characterFromID("Redmond_officiant"));
					LAi_group_MoveCharacter(characterFromID("Redmond_officiant"), "ENGLAND_CITIZENS");
				break;

				case "Oxbay_tavern":
					LAi_SetWaitressType(characterFromID("Oxbay_officiant"));
					LAi_group_MoveCharacter(characterFromID("Oxbay_officiant"), "ENGLAND_CITIZENS");
				break;

				case "Greenford_tavern":
					LAi_SetWaitressType(characterFromID("Greenford_officiant"));
					LAi_group_MoveCharacter(characterFromID("Greenford_officiant"), "ENGLAND_CITIZENS");
				break;

				case "Falaise_De_Fleur_tavern":
					LAi_SetWaitressType(characterFromID("Falaise_De_fleur_officiant"));
					LAi_group_MoveCharacter(characterFromID("Falaise_De_fleur_officiant"), "FRANCE_CITIZENS");
				break;

				case "Muelle_tavern":
					LAi_SetWaitressType(characterFromID("Muelle_officiant"));
					LAi_group_MoveCharacter(characterFromID("Muelle_officiant"), "SPAIN_CITIZENS");
				break;

				case "Douwesen_tavern":
					LAi_SetWaitressType(characterFromID("Douwesen_officiant"));
					LAi_group_MoveCharacter(characterFromID("Douwesen_officiant"), "DOUWESEN_CITIZENS");
				break;

				case "Pirate_tavern":
					LAi_SetWaitressType(characterFromID("Pirate_officiant"));
					LAi_group_MoveCharacter(characterFromID("Pirate_officiant"), "DOUWESEN_PIRATE_CITIZENS");
				break;

				case "Conceicao_tavern":
					LAi_SetWaitressType(characterFromID("Conceicao_officiant"));
					LAi_group_MoveCharacter(characterFromID("Conceicao_officiant"), "CONCEICAO_CITIZENS");
				break;

				case "Smugglers_tavern":
					LAi_SetWaitressType(characterFromID("Smugglers_officiant"));
					LAi_group_MoveCharacter(characterFromID("Smugglers_officiant"), "SMUGGLERS_CITIZENS");
				break;

				case "QC_tavern":
					LAi_SetWaitressType(characterFromID("QC_officiant"));
					LAi_group_MoveCharacter(characterFromID("QC_officiant"), "QC_CITIZENS");
				break;

				case "QC_brothel"://<<------------------------------------------------------------------Added here, Love Verruckt
					LAi_SetWaitressType(characterFromID("wench2"));
					LAi_group_MoveCharacter(characterFromID("wench2"), "QC_CITIZENS");
				break;
			}
		break;

		case "alc":
			LAi_Fade("alc_2_prepare", "alc2");
		break;

		case "alc_2_prepare":
			LAi_SetSitType(pchar);
			LAi_SetActorType(characterFromID(pchar.quest.friend_in_tavern));
			LAi_ActorSetSitMode(characterFromID(pchar.quest.friend_in_tavern));

			GetCharacterPos(pchar, &Land_posx[0], &Land_posy[0], &Land_posz[0]);	//ASVS
			GetCharacterAy(pchar, &Land_angle[0]);									//ASVS

			switch(pchar.location)
			{
				case "Redmond_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "redmond_tavern", "sit", "sit11");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit3")
					{
						ChangeCharacterAddressGroup(pchar, "redmond_tavern", "sit", "sit2");
					}
				break;

				case "Oxbay_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "oxbay_tavern", "sit", "sit11");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit3")
					{
						ChangeCharacterAddressGroup(pchar, "oxbay_tavern", "sit", "sit2");
					}
				break;

				case "Greenford_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit5")
					{
						ChangeCharacterAddressGroup(pchar, "greenford_tavern", "sit", "sit6");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "greenford_tavern", "sit", "sit2");
					}
				break;

				case "Falaise_De_Fleur_tavern":
					// PB: EMPTY???
				break;

				case "Muelle_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "muelle_tavern", "sit", "sit2");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit7")
					{
						ChangeCharacterAddressGroup(pchar, "muelle_tavern", "sit", "sit3");
					}
				break;

				case "Douwesen_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "douwesen_tavern", "sit", "sit2");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit7")
					{
						ChangeCharacterAddressGroup(pchar, "douwesen_tavern", "sit", "sit3");
					}
				break;

				case "Pirate_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "pirate_tavern", "sit", "sit2");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit4")
					{
						ChangeCharacterAddressGroup(pchar, "pirate_tavern", "sit", "sit2");
					}
				break;

				case "Conceicao_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "conceicao_tavern", "sit", "sit2");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit7")
					{
						ChangeCharacterAddressGroup(pchar, "conceicao_tavern", "sit", "sit3");
					}
				break;

				case "Smugglers_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit5")
					{
						ChangeCharacterAddressGroup(pchar, "smugglers_tavern", "sit", "sit6");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit4")
					{
						ChangeCharacterAddressGroup(pchar, "smugglers_tavern", "sit", "sit3");
					}
				break;

				case "QC_tavern":
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "QC_tavern", "sit", "sit2");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit3")
					{
						ChangeCharacterAddressGroup(pchar, "QC_tavern", "sit", "sit7");
					}
				break;

				case "QC_brothel"://<<<<------------------------------------------------------------------Added This, Love Verruckt
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit1")
					{
						ChangeCharacterAddressGroup(pchar, "QC_brothel", "sit", "sit11");
					}
					if (characters[GetCharacterIndex(pchar.quest.friend_in_tavern)].location.locator == "sit3")
					{
						ChangeCharacterAddressGroup(pchar, "QC_brothel", "sit", "sit2");
					}
				break;

				// default:
					GetCharacterPos(characters[GetCharacterIndex(pchar.quest.friend_in_tavern)], &x, &y, &z);
					if(!CheckAttribute(pchar,"habitue.location")) pchar.habitue.location = pchar.location;
					else
					{
						if(pchar.habitue.location!=pchar.location) pchar.habitue.location = pchar.location;
					}

					if(!CheckAttribute(pchar,"habitue.locator"))
					{
						nearloc = LAi_FindNearestFreeLocator("sit", x, y, z);
						pchar.habitue.locator = nearloc;
					}
					else
					{
						if(pchar.habitue.location!=pchar.location) nearloc = LAi_FindNearestFreeLocator("sit", x, y, z);
						else nearloc = pchar.habitue.locator;
					}
					ChangeCharacterAddressGroup(pchar, pchar.location, "sit", pchar.habitue.locator);
			}
		break;

		case "alc2":
			LAi_ActorDialogNow(characterFromID(pchar.quest.friend_in_tavern), pchar, "", -1);
		break;

		case "exit_sit":
			if (CheckQuestAttribute("fight_in_tavern", "fight"))
			{
				pchar.quest.fight_in_tavern = "0";
				LAi_SetSitType(characterFromID(pchar.quest.friend_in_tavern));
			}
			else
			{
				if (pchar.location.group == "sit")
				{
					LAi_SetPlayerType(pchar);
					LAi_SetSitType(characterFromID(pchar.quest.friend_in_tavern));
					LAi_Fade("exit_sit_2", "");
				}
			}
		break;

		case "exit_sit_2":
			homelocation = pchar.quest.friend_in_tavern;
			LAi_SetSitType(characterFromID(homelocation));
			LAi_SetPlayerType(pchar);
			switch(pchar.location)
			{
				case "Redmond_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "ENGLAND_CITIZENS");
				break;

				case "Oxbay_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "ENGLAND_CITIZENS");
				break;

				case "Greenford_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "ENGLAND_CITIZENS");
				break;

				case "Falaise_De_Fleur_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "FRANCE_CITIZENS");
				break;

				case "Muelle_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "SPAIN_CITIZENS");
				break;

				case "Douwesen_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "DOUWESEN_CITIZENS");
				break;

				case "Pirate_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "DOUWESEN_PIRATE_CITIZENS");
				break;

				case "Conceicao_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "CONCEICAO_CITIZENS");
				break;

				case "Smugglers_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "SMUGGLERS_CITIZENS");
				break;

				case "QC_tavern":
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "QC_CITIZENS");
				break;

				case "QC_brothel"://<---------------------------------------------------------------HERE Brothel Mod , love Verruckt!
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), "QC_CITIZENS");
				break;

//				case "default":// MAXIMUS [for new locations]
/*					string charGroup = "QC_CITIZENS";
					for(int log=0; log<LAi_numloginedcharacters; log++)
					{
						int logIdx = LAi_loginedcharacters[log];
						if(logIdx>=0 && !bAllies(&Characters[logIdx]) && !LAi_IsDead(&Characters[logIdx]) && CheckAttribute(&Characters[logIdx],"chr_ai.group") && CheckAttribute(&Characters[logIdx],"chr_ai.type") && Characters[logIdx].chr_ai.type==LAI_TYPE_BARMAN)
						{
							charGroup = Characters[logIdx].chr_ai.group; break;
						}
					}*/
					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), GetCurrentCitizenGroup());
//					LAi_group_MoveCharacter(characterFromID(pchar.quest.friend_in_tavern), charGroup);
/*					GetCharacterPos(&characters[GetCharacterIndex(pchar.quest.friend_in_tavern)], &x, &y, &z);
					nearloc = LAi_FindNearestFreeLocator("goto", x, y, z);
					ChangeCharacterAddress(pchar, pchar.location, nearloc);
*/					if(CheckAttribute(pchar,"habitue.locator"))
					{
						if(pchar.habitue.location!=pchar.location) DeleteAttribute(pchar,"habitue.locator");
					}
//				break;
			}
			TeleportCharacterToPosAy(pchar, Land_posx[0], Land_posy[0], Land_posz[0], Land_angle[0]);
		break;

		case "kill_tavern_fightman_complete":
			LAi_SetStayType(pchar);
			LAi_LocationFightDisable(&Locations[FindLocation(pchar.location)], true);
			LAi_SetPlayerType(pchar);
		break;

		// NK -->
		case "marriageduel":
			//PChar.marriageduel.loc = PCHar.location;
			//PChar.marriageduel.MRid
			//for now, just spawn character here.
			string loc;
			float dist;
			GetNearLocator( "goto", &dist, &loc, 0);
			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, SelectSoldierModelbyLocationNation("", "officer"), "goto", loc);
			sld.id = "Suitor";
			sld.nation = Characters[GetCharacterIndex(PChar.marriageduel.MRid)].nation;
			LAi_SetActorType(CharacterFromID("Suitor"));
			sld.dialog.filename = "Gov MR_dialog.c";
			sld.dialog.currentnode = "engarde";
			LAi_ActorDialog(CharacterFromID("Suitor"), PChar, "", 0.01, 1.0);
		break;

		case "marriageduel_fight":
			LAi_LocationFightDisable(&Locations[FindLocation(PChar.location)], false);
			LAi_SetWarriorType(CharacterFromID("Suitor"));
			LAi_group_MoveCharacter(characterFromID("Suitor"), "BANDITS");
			LAi_group_FightGroups("BANDITS", LAI_GROUP_PLAYER, true);
			LAi_SetCheckMinHP(CharacterFromID("Suitor"), 0.875*LAi_GetCharacterHP(characterFromID("Suitor")), true, "marriageduel_won"); // KK
		break;

		case "marriageduel_won":
			LAi_LocationFightDisable(&Locations[FindLocation(PChar.location)], true);
			LAi_SetFightMode(GetMainCharacter(), false)
			sld = CharacterFromID("Suitor");
			LAi_SetImmortal(CharacterFromID("Suitor"), false);
			LAi_SetActorType(CharacterFromID("Suitor"));
			sld.dialog.currentnode = "duelend";
			LAi_ActorDialog(CharacterFromID("Suitor"), PChar, "", 0.01, 1.0);
		break;

		case "marriageduel_end":
			ChangeCharacterAddress(CharacterFromID("Suitor"), "none", "none");
			sld = CharacterFromID(PChar.marriageduel.MRid);
			sld.dialog.currentnode = "married";
			LAi_ActorDialogNow(sld, PChar, "", -1);
		break;

		case "RemoveMRs":
			ClearMRLocations();
		break;

		// NK 05-04-17 add "updatedays" handler for when you want the day to update but
		case "updatedays":
			PChar = GetMainCharacter();
			if(!CheckAttribute(PChar,"updatedays")) break;
			int daysn = sti(PChar.updatedays);
			bool disableDCU = CheckAttribute(PChar,"updatedays.disableDCU");
			bool curDCU = !CheckAttribute(PChar,"disableDCU");
			bool disableIT = CheckAttribute(PChar,"updatedays.disableIT");
			bool curIT = CheckAttribute(ShipLookupTable,"itemtraders") && sti(ShipLookupTable.itemtraders);
			if(disableDCU) PChar.disableDCU = true;
			if(disableIT && curIT) ShipLookupTable.itemtraders = false;
			//if(FindLoadedLocation() != -1) LAi_Fade("", "");
			int s, dn;
			//int start = 0; if(CheckAttribute(wdmgrid,"lastupdate.day")) { start = sti(wdmgrid.lastupdate.start)+1; }
			for(dn = 0; dn < daysn-1; dn++)
			{
				//trace("Gauging: Start day " + dn);
				AddDataToCurrent(0, 0, 1, false);
				ReloadProgressUpdate();
				DailyCrewUpdate();
				//ReloadProgressUpdate();
				UpdateAllTowns(false);
				//trace("Gauging: Towns done");
				//ReloadProgressUpdate();
				UpdateAllStores(false);
				//wdmFleetsUpdateDay(); //wdmFleetsUpdate(false, false); // WM 05-04-24
			}
			if(curDCU) DeleteAttribute(PChar,"disableDCU");
			ReloadProgressUpdate();

			if(curIT)
			{
				ShipLookupTable.itemtraders = true;
				UpdateAllItemTraders(2); // make everyone blank, but put off the actual updates until you speak with them.
			}
			ReloadProgressUpdate();
			AddDataToCurrent(0, 0, 1, true); // do the last day with the normal post.
			DeleteAttribute(PChar,"updatedays");
		break;
// NK <--

		// MAXIMUS =================================== Prisoners and Captived Captains Section =================================== >
		case "Surrendered_Captain_Dialog":
			LAi_SetPlayerType(PChar);
			if(CheckAttribute(PChar,"quest.CaptiveIdx"))
			{
				LAi_SetStayType(GetCharacter(sti(PChar.quest.CaptiveIdx)));
				DialogMain(GetCharacter(sti(PChar.quest.CaptiveIdx)));
				DeleteAttribute(PChar,"quest.CaptiveIdx");
			}
		break;

		case "Surrendered_Captain_Poor":
			if(CheckAttribute(PChar,"prisonerIDX"))
			{
				LAi_SetPoorType(&characters[makeint(PChar.prisonerIDX)]);
				DeleteAttribute(PChar,"prisonerIDX");
			}
		break;

		case "Surrendered_Captain_Stay":
			if(CheckAttribute(PChar,"prisonerIDX")) LAi_SetStayType(&characters[makeint(PChar.prisonerIDX)]);
		break;

		case "Surrendered_Captain_Turn":
			if(CheckAttribute(PChar,"prisonerIDX"))
			{
				LAi_ActorTurnToCharacter(&characters[makeint(PChar.prisonerIDX)], PChar);
				LAi_SetStayType(&characters[makeint(PChar.prisonerIDX)]);
			}
		break;

		case "Surrendered_Captain_Afraid":
			if(CheckAttribute(PChar,"prisonerIDX"))
			{
				LAi_ActorAnimation(&characters[makeint(PChar.prisonerIDX)], "afraid","", -1);
				DeleteAttribute(PChar,"prisonerIDX");
			}
		break;

		case "Surrendered_Captain_Dead":
			if(CheckAttribute(PChar,"prisonerIDX"))
			{
				switch(Rand(1))
				{
					case 0: LAi_ActorAnimation(&characters[makeint(PChar.prisonerIDX)], "death_afraid_1","", -1); break;
					case 1: LAi_ActorAnimation(&characters[makeint(PChar.prisonerIDX)], "death_afraid_2","", -1); break;
				}
				DeleteAttribute(PChar,"prisonerIDX");
			}
		break;

		case "Surrendered_Captain_Dead1":
			if(CheckAttribute(PChar,"prisonerIDX"))
			{
				NPChar = GetCharacter(sti(PChar.prisonerIDX));
				LAi_ActorAnimation(NPChar, "Ground_Afraid_Death","", -1);
				RemovePassenger(PChar,NPChar);
				DeleteAttribute(NPChar,"prisoned");
				DeleteAttribute(PChar,"prisonerIDX");
			}
		break;

		case "Surrendered_Captain_Run":
			if(CheckAttribute(PChar,"prisonerIDX"))
			{
				NPChar = GetCharacter(sti(PChar.prisonerIDX));
				LAi_ActorRunToLocation(NPChar, "reload", LAi_FindRandomLocator("reload"), "None", "reload", "", "", -1);
				RemovePassenger(PChar,NPChar);
				DeleteAttribute(NPChar,"prisoned");
				DeleteAttribute(PChar,"prisonerIDX");
			}
		break;
		// MAXIMUS =================================== Prisoners and Captived Captains Section =================================== <
		// MAXIMUS =================================== Guadeloupe governor Section =================================== >
		case "ChangeHoverPos1":
			characters[sti(pchar.quest.ChangeHoverPos1.idx)].location	= "PaP_townhall";
			characters[sti(pchar.quest.ChangeHoverPos1.idx)].location.group = "goto";
			characters[sti(pchar.quest.ChangeHoverPos1.idx)].location.locator = "goto8";
			LAi_SetLoginTime(&characters[sti(pchar.quest.ChangeHoverPos1.idx)], 12.0, 24.0);
			LAi_SetHuberStayType(&characters[sti(pchar.quest.ChangeHoverPos1.idx)]);
			LAi_SetStayHuberPointWindow(&characters[sti(pchar.quest.ChangeHoverPos1.idx)], "goto", "goto1");
			LAi_SetStayHuberPointMap(&characters[sti(pchar.quest.ChangeHoverPos1.idx)], "goto", "goto3");
			pchar.quest.ChangeHoverPos1_progress = "completed";
		break;

		case "ChangeHoverPos2":
			characters[sti(pchar.quest.ChangeHoverPos2.idx)].location	= "PaP_townhall";
			characters[sti(pchar.quest.ChangeHoverPos2.idx)].location.group = "sit";
			characters[sti(pchar.quest.ChangeHoverPos2.idx)].location.locator = "sit1";
			LAi_SetLoginTime(&characters[sti(pchar.quest.ChangeHoverPos2.idx)], 0.0, 12.0);
			LAi_SetHuberType(&characters[sti(pchar.quest.ChangeHoverPos2.idx)]);
			pchar.quest.ChangeHoverPos_progress = "completed";
		break;
		// MAXIMUS =================================== Guadeloupe governor Section =================================== <
		// MAXIMUS =================================== Training fight Section =================================== >
		case "StartTrainingFight":
			LAi_SetHP(PChar, makefloat(sti(PChar.skill.Fencing)*50), makefloat(sti(PChar.skill.Fencing)*50));
			LAi_SetFightMode(PChar, true);
			Lai_SetCheckMinHP(Pchar, 0.5*LAi_GetCharacterHP(PChar), false, "TrainingFightFinished1");
			for(int ts=1; ts<sti(PChar.TrainingFight.count)+1; ts++)
			{
				LAi_SetHP(CharacterFromID("TrainingFight_"+ts), makefloat(sti(PChar.skill.Fencing)*50), makefloat(sti(PChar.skill.Fencing)*50));
				Lai_SetImmortal(CharacterFromID("TrainingFight_"+ts), false);
				LAi_SetActorTypeNoGroup(CharacterFromID("TrainingFight_"+ts));
				LAi_ActorAttack(CharacterFromID("TrainingFight_"+ts), Pchar, "");
				Lai_SetCheckMinHP(CharacterFromID("TrainingFight_"+ts), 0.5*LAi_GetCharacterHP(CharacterFromID("TrainingFight_"+ts)), true, "TrainingFightFinished1");
			}
		break;

		case "ContinueTrainingFight":
			LAi_SetHP(PChar, makefloat(sti(PChar.skill.Fencing)*50), makefloat(sti(PChar.skill.Fencing)*50));
			LAi_SetFightMode(PChar, true);
			Lai_SetCheckMinHP(Pchar, 0.5*LAi_GetCharacterHP(PChar), false, "TrainingFightFinished2");
			for(int tc=1; tc<sti(PChar.TrainingFight.count)+1; tc++)
			{
				LAi_SetHP(CharacterFromID("TrainingFight_"+tc), makefloat(sti(PChar.skill.Fencing)*50), makefloat(sti(PChar.skill.Fencing)*50));
				Lai_SetImmortal(CharacterFromID("TrainingFight_"+tc), false);
				LAi_SetActorTypeNoGroup(CharacterFromID("TrainingFight_"+tc));
				LAi_ActorAttack(CharacterFromID("TrainingFight_"+tc), Pchar, "");
				Lai_SetCheckMinHP(CharacterFromID("TrainingFight_"+tc), 0.5*LAi_GetCharacterHP(CharacterFromID("TrainingFight_"+tc)), true, "TrainingFightFinished2");
			}
		break;

		case "TrainingFightFinished1":
			for(int tf=1; tf<sti(PChar.TrainingFight.count)+1; tf++)
			{
				LAi_RemoveCheckMinHP(CharacterFromID("TrainingFight_"+tf));
				LAi_SetCurHPMax(CharacterFromID("TrainingFight_"+tf));
				ResetHP(CharacterFromID("TrainingFight_"+tf));
				LAi_type_actor_Reset(CharacterFromID("TrainingFight_"+tf));
			}

			LAi_RemoveCheckMinHP(Pchar);
			LAi_SetCurHPMax(Pchar);
			ResetHP(Pchar);
			LAi_SetActorTypeNoGroup(PChar);
			Lai_ActorWaitDialog(Pchar, CharacterFromID("TrainingFight_1"));
			LAi_SetFightMode(PChar, false);
			Lai_QuestDelay("ReturnPlayer", 1.5);

			Characters[sti(PChar.TrainingFight.leader)].Dialog.CurrentNode = "EnoughForYou1";
			LAi_ActorDialog(CharacterFromID("TrainingFight_1"), PChar, "", 1.0, 1.0);
		break;

		case "TrainingFightFinished2":
			for(int te=1; te<sti(PChar.TrainingFight.count)+1; te++)
			{
				LAi_RemoveCheckMinHP(CharacterFromID("TrainingFight_"+te));
				LAi_SetCurHPMax(CharacterFromID("TrainingFight_"+te));
				ResetHP(CharacterFromID("TrainingFight_"+te));
				LAi_type_actor_Reset(CharacterFromID("TrainingFight_"+te));
			}

			LAi_RemoveCheckMinHP(Pchar);
			LAi_SetCurHPMax(Pchar);
			ResetHP(Pchar);
			LAi_SetActorTypeNoGroup(PChar);
			Lai_ActorWaitDialog(Pchar, CharacterFromID("TrainingFight_1"));
			LAi_SetFightMode(PChar, false);
			Lai_QuestDelay("ReturnPlayer", 1.5);

			Characters[sti(PChar.TrainingFight.leader)].Dialog.CurrentNode = "EnoughForYou2";
			LAi_ActorDialog(&Characters[sti(PChar.TrainingFight.leader)], PChar, "", 1.0, 1.0);
		break;

		case "ReturnPlayer":
			LAi_SetPlayerType(Pchar);
		break;

		case "piratefun":
			SetRelationsAsNation(PIRATE); // PB: Simpler
			PChar.nation	= PIRATE;
			// RM -->
			/*SetNationRelation2MainCharacter(ENGLAND, RELATION_ENEMY);
			SetNationRelation2MainCharacter(FRANCE, RELATION_ENEMY);
			SetNationRelation2MainCharacter(SPAIN, RELATION_ENEMY);
			SetNationRelation2MainCharacter(PORTUGAL, RELATION_ENEMY);
			SetNationRelation2MainCharacter(PIRATE, RELATION_FRIEND);
			SetNationRelation2MainCharacter(HOLLAND, RELATION_ENEMY);*/
			/*LeaveService(PChar, ENGLAND, false);
			LeaveService(PChar, FRANCE, false);
			LeaveService(PChar, SPAIN, false);
			LeaveService(PChar, HOLLAND, false);
			LeaveService(PChar, PORTUGAL, false);
			if(GetRMRelation(GetMainCharacter(), PIRATE) < REL_AMNESTY) SetRMRelation(GetMainCharacter(), PIRATE, REL_AMNESTY);*/
			// RM <--
		break;

		// MAXIMUS =================================== Training fight Section =================================== <

// KK ----------------- Resurrection Event -------------------------------------
		case "PreResurrection":
			if (Resurrectingofficiant.id == "Eleuthera_officiant")
			{
				ChangeCharacterAddressGroup(ResurrectingOfficiant, ResurrectingOfficiant.resurrection.location, "goto", "stab");
				PChar.quest.ResurrectionEvent.win_condition.l1 = "location";
				PChar.quest.ResurrectionEvent.win_condition.l1.location = ResurrectingOfficiant.resurrection.location;
				PChar.quest.ResurrectionEvent.win_condition = "ResurrectionEvent";
				DoReloadCharacterToLocation(ResurrectingOfficiant.resurrection.location, "goto", "goto3");
			}
			else
			{
				ChangeCharacterAddressGroup(ResurrectingOfficiant, ResurrectingOfficiant.resurrection.location, "goto", "goto3");
				PChar.quest.ResurrectionEvent.win_condition.l1 = "location";
				PChar.quest.ResurrectionEvent.win_condition.l1.location = ResurrectingOfficiant.resurrection.location;
				PChar.quest.ResurrectionEvent.win_condition = "ResurrectionEvent";
				DoReloadCharacterToLocation(ResurrectingOfficiant.resurrection.location, "goto", "goto2");
			}
			PChar.NoSave.Resurrection = 1;
			Locations[FindLocation(ResurrectingOfficiant.resurrection.location)].reload.l1.disable = 1;
			Log_SetStringToLog(TranslateString("","You regain consciousness after a long feverish sleep"));
			PlaySound("AMBIENT\SHOP\sigh2.wav");
		break;

		case "ResurrectionEvent":
			if (GetActualNationRelation2MainCharacter(GetCurrentLocationNation()) != RELATION_ENEMY)
				LAi_QuestDelay("ResurrectionEvent_BlazeWakes", 0.0);
			else
				LAi_QuestDelay("ResurrectionEvent_BlazeMustEscape", 0.0);
		break;

		case "ResurrectionEvent_BlazeWakes":
			LAi_SetActorType(PChar);
			LAi_SetActorType(ResurrectingOfficiant);
			LAi_ActorFollow(PChar, ResurrectingOfficiant, "", 1.5);
			LAi_ActorFollow(ResurrectingOfficiant, PChar, "ResurrectionEvent_DialogStart", 1.5);
		break;

		case "ResurrectionEvent_DialogStart":
			LAi_type_actor_Reset(PChar);
			LAi_ActorWaitDialog(PChar, ResurrectingOfficiant);
			LAi_ActorDialog(ResurrectingOfficiant, PChar, "", 1.0, 1.0);
			LAi_SetPlayerType(PChar);
		break;

		case "ResurrectionEvent_OfficiantLeaves":
			LAi_SetActorType(ResurrectingOfficiant);
			LAi_ActorGoToLocation(ResurrectingOfficiant, "reload", "reload1", ResurrectingOfficiant.tavern.location, ResurrectingOfficiant.tavern.location.group, ResurrectingOfficiant.tavern.location.locator, "ResurrectionEvent_OfficiantLeftTavernUpstairs", 10.0);
		break;

		case "ResurrectionEvent_OfficiantLeftTavernUpstairs":
			LAi_SetWaitressType(ResurrectingOfficiant);
			Locations[FindLoadedLocation()].reload.l1.disable = 0;
			if (CheckAttribute(PChar, "NoSave.Resurrection")) DeleteAttribute(PChar, "NoSave.Resurrection");
			if (CheckAttribute(PChar, "NoSave")) DeleteAttribute(PChar, "NoSave");
			if (CheckAttribute(ResurrectingOfficiant, "isResurrecting")) DeleteAttribute(ResurrectingOfficiant, "isResurrecting");
		break;

		case "ResurrectionEvent_BlazeMustEscape":
			ResurrectingOfficiant.Dialog.CurrentNode = "Blaze_must_escape";
			LAi_SetActorType(PChar);
			LAi_SetActorType(ResurrectingOfficiant);
			LAi_ActorTurnToCharacter(PChar, ResurrectingOfficiant);
			LAi_ActorFollow(ResurrectingOfficiant, PChar, "ResurrectionEvent_DialogStart", 1.5);
		break;

//	----------- Safe Port Leave ------------------------------------------------

		case "Safe_port_leave":
			iForceDetectionFalseFlag = 0;
			pchar.nation = GetServedNation(); // PB: Restore original flag after false flag
		break;

//	----------- Flag -----------------------------------------------------------
		case "Officer_HoistFlag":
			RefreshFlags();
		break;

//	----------- Colony Capture -------------------------------------------------

		case "ColonyCapture_Capture":
			if (CheckAttribute(PChar, "colony_capture")) {
				CaptureColony(PChar.colony_capture.town, sti(PChar.colony_capture.nation));
				DeleteAttribute(PChar, "colony_capture");
			}
		break;

		case "ColonyCapture_ContinueDialog":
			if (CheckAttribute(PChar, "colony_capture")) {
				NPChar = GetCharacter(sti(PChar.colony_capture.govidx));
				NPChar.Dialog.CurrentNode = "First time";
				NPChar.Dialog.TempNode = "First time";
				LAi_SetActorType(PChar);
				LAi_ActorDialog(PChar, NPChar, "Surrendered_Captain_Dialog", 60.0, 0);	// surrender dialog
			}
		break;

		case "ColonyCapture_TownCommandant_1":
			if (CheckAttribute(PChar, "colony_capture")) {
				NPChar = GetCharacter(sti(PChar.colony_capture.govidx));
				PlaceCharacter(NPChar, "goto");
			}
		break;

		case "ColonyCapture_TownCommandant_2":
			if (CheckAttribute(PChar, "colony_capture")) {
				NPChar = GetCharacter(sti(PChar.colony_capture.govidx));
				LAi_SetActorType(PChar);
				LAi_SetActorType(NPChar);
				Lai_ActorFollow(pchar, NPChar, "ColonyCapture_TownCommandant_3", 2.0);
			}
		break;

		case "ColonyCapture_TownCommandant_3":
			if (CheckAttribute(PChar, "colony_capture")) {
				NPChar = GetCharacter(sti(PChar.colony_capture.govidx));
				DeleteAttribute(PChar, "colony_capture");
				LAi_ActorWaitDialog(pchar, NPChar);
				LAi_SetActorType(NPChar);
				LAi_ActorDialog(NPChar, PChar, "player_back", 10.0, 1.0);
			}
		break;

//	----------- Boarding & Mutiny ----------------------------------------------
		case "Abordage_Quest":
			PChar.quest.Abordage_End.win_condition.l1 = "Group_Death";
			PChar.quest.Abordage_End.win_condition.l1.group = LAI_GROUP_BRDENEMY;
			PChar.quest.Abordage_End.win_condition = "Abordage_End";
		break;

		case "Abordage_End":
			if (bMutinyDeckStarted) {
				PostEvent("LAi_event_mutiny_EnableReload", 1000.0);
			} else {
				if (LAi_IsBoardingProcess()) PostEvent("LAi_event_boarding_EnableReload", 1000.0);
			}
		break;
// <-- KK

		case "reset_abordage":
			//log_setStringToLog("Abordage characters was reseted");
			pchar.quest.abordage = 0;
		break;

		case "DPFader": DPDoFade(); break;
	
		case "stand_up":
			LAi_Fade("stand_up1", "stand_up2");
			LAi_SetPlayerType(Pchar); 
		break;
	
		case "stand_up1":
// NK -->
			if(CheckAttribute(pchar, "quest.Attwood1.leave"))
			{
				DeleteAttribute(pchar, "quest.Attwood1.leave");
				ChangeCharacterAddressGroup(CharacterFromID("Jack Greenfield"), "none", "sit", "sit10");
				ChangeCharacterAddressGroup(CharacterFromID("Martin Warner"), "none", "sit", "sit5");
			}
// NK <--
			TeleportCharacterToLocator(Pchar, "goto", "goto20");
			LAi_ActorSetStayMode(Pchar);
		break;
	
		case "stand_up2":
			LAi_SetPlayerType(Pchar); 
		break;

//============================================================================
// SIDE QUESTS
//============================================================================

//------------------
//Tortuga Atmosphere
//------------------

		case "Tortuga_start":
			PChar.quest.Tortuga_atmosphere.win_condition.l1 = "location";
			PChar.quest.Tortuga_atmosphere.win_condition.l1.character = PChar.id;
			PChar.quest.Tortuga_atmosphere.win_condition.l1.location = "Tortuga_port";
			PChar.quest.Tortuga_atmosphere.win_condition = "Tortuga_atmosphere";
		break;

		case "Tortuga_atmosphere":
			Pchar.quest.Tortuga_start.win_condition.l1 = "ExitFromLocation";
			Pchar.quest.Tortuga_start.win_condition.l1.location = "Tortuga_port";
			Pchar.quest.Tortuga_start.win_condition = "Tortuga_start";

			if(!CheckAttribute(PChar,"scarlett"))
			{
				sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "Towngirl7", "goto", LAi_FindRandomLocator("goto"));
				LAi_SetImmortal(sld, true);
				sld.dialog.filename = "Dame_dialog.c";
				sld.id = "dame1";
				sld.name = "Scarlett";
				sld.lastname = "";
				LAi_SetCitizenType(characterFromID("dame1"));

				sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "Towngirl1_1", "goto", LAi_FindRandomLocator("goto"));
				LAi_SetImmortal(sld, true);
				sld.dialog.filename = "Dame_dialog.c";
				sld.id = "dame2";
				sld.name = "Giselle";
				sld.lastname = "";
				LAi_SetCitizenType(characterFromID("dame2"));

				sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "Danblack", "goto", LAi_FindRandomLocator("goto"));
				LAi_SetImmortal(sld, true);
				sld.dialog.filename = "Dame_dialog.c";
				sld.id = "dame3";
				sld.name = "Annamaria";
				sld.lastname = "";
				LAi_SetCitizenType(characterFromID("dame3"));
			}
			else
			{
				sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeSex(-1, "women", "woman"), "goto", LAi_FindRandomLocator("goto"));
				LAi_SetImmortal(sld, true);
				sld.dialog.filename = "Dame_dialog.c";
				sld.id = "dame1";
				LAi_SetCitizenType(characterFromID("dame1"));

				sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeSex(-1, "women", "woman"), "goto", LAi_FindRandomLocator("goto"));
				LAi_SetImmortal(sld, true);
				sld.dialog.filename = "Dame_dialog.c";
				sld.id = "dame2";
				LAi_SetCitizenType(characterFromID("dame2"));

				sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeSex(-1, "women", "woman"), "goto", LAi_FindRandomLocator("goto"));
				LAi_SetImmortal(sld, true);
				sld.dialog.filename = "Dame_dialog.c";
				sld.id = "dame3";
				LAi_SetCitizenType(characterFromID("dame3"));
			}

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeNation(1, "Captains", PIRATE), "goto", LAi_FindRandomLocator("goto"));
			LAi_SetImmortal(sld, true);
			LAi_group_MoveCharacter(sld, "bagarreur");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeNation(1, "Captains", PIRATE), "goto", LAi_FindRandomLocator("goto"));
		    LAi_SetImmortal(sld, true);
			LAi_group_MoveCharacter(sld, "bagarreur1");
            LAi_group_FightGroups("bagarreur", "bagarreur1", true);

            sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeNation(1, "Captains", PIRATE), "goto", LAi_FindRandomLocator("goto"));
			LAi_SetImmortal(sld, true);
			LAi_group_MoveCharacter(sld, "bagarreur2");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeNation(1, "Captains", PIRATE), "goto", LAi_FindRandomLocator("goto"));
		    LAi_SetImmortal(sld, true);
			LAi_group_MoveCharacter(sld, "bagarreur3");
            LAi_group_FightGroups("bagarreur2", "bagarreur3", true);

            sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeNation(1, "Captains", PIRATE), "goto", LAi_FindRandomLocator("goto"));
			LAi_SetImmortal(sld, true);
			LAi_group_MoveCharacter(sld, "bagarreur4");

			sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForTypeNation(1, "Captains", PIRATE), "goto", LAi_FindRandomLocator("goto"));
		    LAi_SetImmortal(sld, true);
			LAi_group_MoveCharacter(sld, "bagarreur5");
            LAi_group_FightGroups("bagarreur4", "bagarreur5", true);

			if(rand(100) < 50)
			{
				string SkelLocator = LAi_FindRandomLocator("goto");
				sld = LAi_CreateFantomCharacter(false, 0, true, false, 0.25, GetRandomModelForType(-1,"Monks"), "goto", SkelLocator);
				LAi_SetImmortal(sld, true);
				sld.id = "bagarreur6";
				sld.name = "Scared";
				sld.lastname = "Monk";
				LAi_SetActorType(characterFromID("bagarreur6"));
				LAi_ActorRunToLocation(characterFromID("bagarreur6"), "reload", "reload7_back", "none", "", "", "skeleton_leaves", 0.0);

				sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, GetRandomModelForType(-1,"Skeletons"), "goto", SkelLocator);
				LAi_SetImmortal(sld, true);
				sld.id = "bagarreur7";
				sld.name = "Cursed";
				sld.lastname = "Skeleton";
				LAi_SetWarriorType(characterFromID("bagarreur7"));
				LAi_warrior_SetCommander(CharacterFromID("bagarreur7"), CharacterFromID("bagarreur6"));
			}
        break;

		case "skeleton_leaves":
			LAi_SetActorType(characterFromID("bagarreur7"));
			LAi_ActorGoToLocation(characterFromID("bagarreur7"), "reload", LAi_FindRandomLocator("reload"), "None", "reload", "", "", -1);
		break;

		case "Dame_1":
			LAi_ActorGoToLocation(TortugaDame1, "reload", LAi_FindRandomLocator("reload"), "None", "reload", "", "", -1);

			switch(TortugaDame1.id)
			{
				case "dame1":
					switch(rand(1))
					{
						case 0: TortugaDame2 = characterFromID("dame2"); TortugaDame3 = characterFromID("dame3"); break;
						case 1: TortugaDame2 = characterFromID("dame3"); TortugaDame3 = characterFromID("dame2"); break;
					}
				break;

				case "dame2":
					switch(rand(1))
					{
						case 0: TortugaDame2 = characterFromID("dame1"); TortugaDame3 = characterFromID("dame3"); break;
						case 1: TortugaDame2 = characterFromID("dame3"); TortugaDame3 = characterFromID("dame1"); break;
					}
				break;

				case "dame3":
					switch(rand(1))
					{
						case 0: TortugaDame2 = characterFromID("dame1"); TortugaDame3 = characterFromID("dame2"); break;
						case 1: TortugaDame2 = characterFromID("dame2"); TortugaDame3 = characterFromID("dame1"); break;
					}
				break;
			}

			LAi_SetActorType(TortugaDame2);
			LAi_ActorFollow(TortugaDame2, PChar, "Dame_2", 100.5);
			TortugaDame2.dialog.currentnode = "begin_2";
			LAi_SetActorType(TortugaDame3);
			LAi_ActorFollow(TortugaDame3, PChar, "Dame_2", 100.5);
			TortugaDame3.dialog.currentnode = "begin_2";
		break;

		case "Dame_2":
			LAi_ActorWaitDialog(PChar, TortugaDame2);
			LAi_ActorDialog(TortugaDame2, PChar, "", 1.0, 1.0);

			LAi_ActorWaitDialog(PChar, TortugaDame3);
			LAi_ActorDialog(TortugaDame3, PChar, "", 1.0, 1.0);
		break;

		case "Dame_3":
			LAi_ActorGoToLocation(TortugaDame2, "reload", LAi_FindRandomLocator("reload"), "None", "reload", "", "", -1);

			switch(TortugaDame1.id)
			{
				case "dame1":
					switch(TortugaDame2.id)
					{
						case "dame2": TortugaDame3 = characterFromID("dame3"); break;
						case "dame3": TortugaDame3 = characterFromID("dame2"); break;
					}
				break;

				case "dame2":
					switch(TortugaDame2.id)
					{
						case "dame1": TortugaDame3 = characterFromID("dame3"); break;
						case "dame3": TortugaDame3 = characterFromID("dame1"); break;
					}
				break;

				case "dame3":
					switch(TortugaDame2.id)
					{
						case "dame1": TortugaDame3 = characterFromID("dame2"); break;
						case "dame2": TortugaDame3 = characterFromID("dame1"); break;
					}
				break;
			}

			LAi_SetActorType(TortugaDame3);
			LAi_ActorFollow(TortugaDame3, PChar, "Dame_4", 100.5);
			TortugaDame3.dialog.currentnode = "begin_4";
		break;

		case "Dame_4":
			LAi_ActorWaitDialog(PChar, TortugaDame3);
			LAi_ActorDialog(TortugaDame3, PChar, "", 1.0, 1.0);
		break;

		case "Dame_5":
			LAi_ActorGoToLocation(TortugaDame3, "reload", LAi_FindRandomLocator("reload"), "None", "reload", "", "", -1);
		break;

		case "Muerte_restore":
			PChar.quest.Muerte_start.win_condition.l1 = "location";
			PChar.quest.Muerte_start.win_condition.l1.character = PChar.id;
			PChar.quest.Muerte_start.win_condition.l1.location = "Tortuga_tavern";
			PChar.quest.Muerte_start.win_condition = "Muerte_start";
		break;

		case "Muerte_start":
			Pchar.quest.Muerte_restore.win_condition.l1 = "ExitFromLocation";
			Pchar.quest.Muerte_restore.win_condition.l1.location = "Tortuga_tavern";
			Pchar.quest.Muerte_restore.win_condition = "Muerte_restore";
			if(!CheckAttribute(PChar,"gibbs"))
			{
				sld = LAi_CreateFantomCharacter(false, 0, true, true, 0.25, "bocman5", "sit", "sit5");
				LAi_SetImmortal(sld, true);
				sld.dialog.filename = "Mr. Gibbs_dialog.c";
				sld.money = rand(100);
				sld.id = "Mr. Gibbs";
				sld.name = "Joshamee";
				sld.lastname = "Gibbs";
				sld.reputation = 65;
				sld.quest.officertype = OFFIC_TYPE_BOATSWAIN;
				sld.quest.officerprice = 0;//PB
				LAi_SetSitType(sld);
				LAi_group_MoveCharacter(sld, "TORTUGA_CITIZENS");
				LAi_SetImmortal(sld, true);
			}
		break;

		// PB: Shotgun Easter Egg -->
		case "clint_eastwood":
			LAi_SetActorType(CharacterFromID("Clint Eastwood"));
			LAi_ActorDialog(CharacterFromID("Clint Eastwood"), PChar, "", 0.0, 0.0);
		break;
		// PB: Shotgun Easter Egg <--

		case "oxbay_port_earthquake":
			// PB: Move this here, so the buildings are gone only AFTER you entered the map sailing mode
			port = &Locations[FindLocation("Oxbay_port")];    // ccc Feb06
			if(CheckAttribute(port,"building") ) DeleteAttribute(port,"building");    // ccc Feb06
		break;

//============================================================================
// OTHER
//============================================================================

// JRH -->
		case "place_mtoon_on_back":
			//from seadogs

			if(CheckAttribute(weapon,"model") && weapon.model == "musketoon")
			{
				weapon.model = "musketoon_back";
				RemoveCharacterEquip(Pchar, GUN_ITEM_TYPE );
				EquipCharacterByItem(Pchar, "pistolmtoon");
				PlaySound("OBJECTS\duel\reload1.wav");

				if(CheckAttribute(Pchar,"quest.mtoon_status"))
				{
					if(Pchar.quest.mtoon_status == "unloaded")
					{
						Pchar.chr_ai.charge = "0";
						Pchar.chr_ai.chargeprc = "1";
					}

					if(Pchar.quest.mtoon_status == "loaded")
					{
						Pchar.chr_ai.charge = "1";
						Pchar.chr_ai.chargeprc = "0";
					}
				}
			}
		break;

		case "place_mtoon_on_hip":
			//from seadogs

			if(CheckAttribute(weapon,"model") && weapon.model == "musketoon_back")
			{
				Pchar.quest.mtoon_status = "loaded";
				weapon.model = "musketoon";
				RemoveCharacterEquip(Pchar, GUN_ITEM_TYPE );
				EquipCharacterByItem(Pchar, "pistolmtoon");
				PlaySound("OBJECTS\duel\reload1.wav");
			}
		break;

		case "place_mket_on_back":
			//from seadogs

			if(CheckAttribute(weapon,"model") && weapon.model == "musket")
			{
				weapon.model = "musket_back";
				RemoveCharacterEquip(Pchar, GUN_ITEM_TYPE );
				EquipCharacterByItem(Pchar, "pistolmket");
				PlaySound("OBJECTS\duel\reload1.wav");

				if(CheckAttribute(Pchar,"quest.mket_status"))
				{
					if(Pchar.quest.mket_status == "unloaded")
					{
						Pchar.chr_ai.charge = "0";
						Pchar.chr_ai.chargeprc = "1";
					}

					if(Pchar.quest.mket_status == "loaded")
					{
						Pchar.chr_ai.charge = "1";
						Pchar.chr_ai.chargeprc = "0";
					}
				}
			}
		break;

		case "place_mket_on_hip":
			//from seadogs

			if(CheckAttribute(weapon,"model") && weapon.model == "musket_back")
			{
				Pchar.quest.mket_status = "loaded";
				weapon.model = "musket";
				RemoveCharacterEquip(Pchar, GUN_ITEM_TYPE );
				EquipCharacterByItem(Pchar, "pistolmket");
				PlaySound("OBJECTS\duel\reload1.wav");
			}
		break;

		case "rifle_recently_fired_delay":
			Pchar.quest.rifle_recently_fired = "no";
		break;
// <-- JRH

		PChar.questnotfound = true; // PB: Testing
	}
}
// <-- KK
